#include "callbacks.h"
#include "interface.h"
#include "effects.h"

#include "support.h"



void 
load_theme (void) {
  // load the theme images
  // TODO - set palette in here ?
  GError *error=NULL;
  gchar *tmp=g_strdup_printf("%s/%s%s/main.jpg",prefs->prefix_dir,THEME_DIR,prefs->theme);
  GdkPixbuf *imsep=gdk_pixbuf_new_from_file(tmp,&error);
  g_free(tmp);
  
  if (!(error==NULL)) {
    palette->style=STYLE_PLAIN;
    g_snprintf(prefs->theme,64,"%%ERROR%%");
    g_error_free(error);
  }
  else {
    mainw->sep_image = gtk_image_new_from_pixbuf (imsep);
    tmp=g_strdup_printf("%s/%s%s/frame.jpg",prefs->prefix_dir,THEME_DIR,prefs->theme);
    mainw->imframe=gdk_pixbuf_new_from_file(tmp,&error);
    g_free(tmp);
    if (!(error==NULL)) {
      g_error_free(error);
    }
  }
}




void 
create_LiVES (void)
{

  GtkWidget *hbox1;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *menuitem11;
  GtkWidget *menuitem11_menu;
  GtkWidget *separatormenuitem2;
  GtkWidget *separatormenuitem3;
  GtkWidget *separatormenuitem11;
  GtkWidget *separatormenuitem110;
  GtkWidget *separatormenuitem99;
  GtkWidget *menuitem12;
  GtkWidget *menuitem12_menu;
  GtkWidget *select_submenu_menu;
  GtkWidget *export_submenu_menu;
  GtkWidget *trimaudio_submenu_menu;
  GtkWidget *delaudio_submenu_menu;
  GtkWidget *menuitemsep;
  GtkWidget *menuitemsep2;
  GtkWidget *image333;
  GtkWidget *image380;
  GtkWidget *image381;
  GtkWidget *separator3;
  GtkWidget *image334;
  GtkWidget *image1334;
  GtkWidget *separator5;
  GtkWidget *separator27;
  GtkWidget *separator55;
  GtkWidget *separator88;
  GtkWidget *menuitem13;
  GtkWidget *menuitem13_menu;
  GtkWidget *image335;
  GtkWidget *image336;
  GtkWidget *image337;
  GtkWidget *image1337;
  GtkWidget *image355;
  GtkWidget *image501;
  GtkWidget *image510;
  GtkWidget *image520;
  GtkWidget *image511;
  GtkWidget *image571;
  GtkWidget *image512;
  GtkWidget *image513;
  GtkWidget *image514;
  GtkWidget *image515;
  GtkWidget *image400;
  GtkWidget *image402;
  GtkWidget *image403;
  GtkWidget *image404;
  GtkWidget *image405;
  GtkWidget *image406;
  GtkWidget *image407;
  GtkWidget *separator8;
  GtkWidget *effects;
  GtkWidget *effects_menu;
  GtkWidget *image339;
  GtkWidget *image340;
  GtkWidget *image341;
  GtkWidget *image342;
  GtkWidget *image343;
  GtkWidget *separator77;
  GtkWidget *separator9;
  GtkWidget *separator19;
  GtkWidget *separator49;
  GtkWidget *separator10;
  GtkWidget *_quick;
  GtkWidget *image344;
  GtkWidget *_slow;
  GtkWidget *image345;
  GtkWidget *separator6;
  GtkWidget *separator26;
  GtkWidget *image346;
  GtkWidget *tools;
  GtkWidget *tools_menu;
  GtkWidget *audio;
  GtkWidget *audio_menu;
  GtkWidget *info;
  GtkWidget *info_menu;
  GtkWidget *vj_menu;
  GtkWidget *toys_menu;
  GtkWidget *win;
  GtkWidget *image347;
  GtkWidget *image348;
  GtkWidget *menuitem14;
  GtkWidget *menuitem14_menu;
  GtkObject *spinbutton_start_adj;
  GtkObject *spinbutton_end_adj;
  GtkWidget *about;
  GtkWidget *vbox4;
  GtkWidget *pf_label;
  GtkWidget *label15;
  GtkWidget *label16;
  GtkWidget *hbox3;
  GtkWidget *t_label;
  GtkWidget *rewindbutton;
  GtkWidget *rewind_img;
  GtkWidget *playselbutton;
  GtkWidget *playsel_img;
  GtkWidget *stopbutton;
  GtkWidget *stop_img;
  GtkWidget *playbutton;
  GtkWidget *play_img;
  GtkWidget *mutebutton;
  GtkWidget *loopbutton;
  GtkWidget *loop_img;

  GtkObject *spinbutton_pb_fps_adj;

  GtkWidget *tmp_toolbar_icon;
  GdkColor *normal;

  gchar buff[256];

  mainw=(mainwindow*)(g_malloc(sizeof(mainwindow)));

  mainw->is_ready=FALSE;
  mainw->current_file=-1;

  mainw->sep_image = gtk_image_new_from_pixbuf (NULL);
  mainw->image272 = gtk_image_new_from_pixbuf (NULL);
  mainw->image273 = gtk_image_new_from_pixbuf (NULL);
  mainw->imframe=NULL;


  if (palette->style&STYLE_1) {
    load_theme();
  }

  if (!(mainw->imframe==NULL)) {
    gtk_image_set_from_pixbuf(GTK_IMAGE(mainw->image272),mainw->imframe);
    gtk_image_set_from_pixbuf(GTK_IMAGE(mainw->image273),mainw->imframe);
  }

  mainw->tooltips = gtk_tooltips_new ();

  mainw->accel_group = GTK_ACCEL_GROUP(gtk_accel_group_new ());
  
  mainw->LiVES = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  gtk_window_set_decorated(GTK_WINDOW(mainw->LiVES),prefs->open_decorated);

  if (palette->style==STYLE_PLAIN) {
    // if gtk_widget_ensure_style is used, we can't grab external frames...
    // gtk_widget_ensure_style(mainw->LiVES);

    normal=&gtk_widget_get_style(mainw->LiVES)->bg[GTK_STATE_NORMAL];
    colour_equal((GdkColor *)(&palette->normal_back),normal);

    normal=&gtk_widget_get_style(mainw->LiVES)->fg[GTK_STATE_NORMAL];
    colour_equal((GdkColor *)(&palette->normal_fore),normal);
  }

  gtk_window_set_default_size (GTK_WINDOW (mainw->LiVES), 760, 480);
 
  gtk_window_set_title (GTK_WINDOW (mainw->LiVES), _("LiVES"));

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (mainw->LiVES), vbox1);

  mainw->menubar = gtk_menu_bar_new ();
  gtk_widget_show (mainw->menubar);
  gtk_box_pack_start (GTK_BOX (vbox1), mainw->menubar, FALSE, FALSE, 0);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(mainw->menubar, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  menuitem11 = gtk_menu_item_new_with_mnemonic ("_File");
  gtk_widget_show (menuitem11);
  gtk_container_add (GTK_CONTAINER (mainw->menubar), menuitem11);

  menuitem11_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem11), menuitem11_menu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(menuitem11_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->open = gtk_menu_item_new_with_mnemonic ("_Open File/Directory");
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->open);
  gtk_widget_add_accelerator (mainw->open, "activate", mainw->accel_group,
                              GDK_o, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  mainw->open_sel = gtk_menu_item_new_with_mnemonic ("O_pen File Selection...");

  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->open_sel);

  mainw->open_loc = gtk_menu_item_new_with_mnemonic ("Open _Location/Stream...");
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->open_loc);
  gtk_widget_add_accelerator (mainw->open_loc, "activate", mainw->accel_group,
                              GDK_l, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  mainw->open_vcd_menu = gtk_menu_item_new_with_mnemonic ("Import Selection from _dvd/vcd...");
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->open_vcd_menu);
  mainw->open_vcd_submenu=gtk_menu_new();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainw->open_vcd_menu), mainw->open_vcd_submenu);
  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(mainw->open_vcd_submenu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->open_dvd = gtk_menu_item_new_with_mnemonic ("Import Selection from _dvd");
  gtk_container_add (GTK_CONTAINER (mainw->open_vcd_submenu), mainw->open_dvd);

  mainw->open_vcd = gtk_menu_item_new_with_mnemonic ("Import Selection from _vcd");
  gtk_container_add (GTK_CONTAINER (mainw->open_vcd_submenu), mainw->open_vcd);

  mainw->open_device_menu = gtk_menu_item_new_with_mnemonic ("_Import from Device");
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->open_device_menu);
  mainw->open_device_submenu=gtk_menu_new();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainw->open_device_menu), mainw->open_device_submenu);
  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(mainw->open_device_submenu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->open_firewire = gtk_menu_item_new_with_mnemonic ("Import from _Firewire Device");
  gtk_container_add (GTK_CONTAINER (mainw->open_device_submenu), mainw->open_firewire);
  gtk_widget_show (mainw->open_firewire);
  gtk_widget_show (mainw->open_device_menu);
  gtk_widget_show (mainw->open_device_submenu);

  if (capable->has_mplayer) {
    gtk_widget_show (mainw->open);
    gtk_widget_show (mainw->open_sel);

#ifdef ENABLE_DVD_GRAB
    gtk_widget_show (mainw->open_vcd_menu);
    gtk_widget_show (mainw->open_vcd_submenu);
    gtk_widget_show (mainw->open_dvd);
    gtk_widget_show (mainw->open_vcd);
#endif
    gtk_widget_show (mainw->open_loc);
  }

  mainw->recent_menu = gtk_menu_item_new_with_mnemonic ("_Recent Files...");
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->recent_menu);
  mainw->recent_submenu=gtk_menu_new();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainw->recent_menu), mainw->recent_submenu);
  memset(buff,0,1);

  // since we are still initialising, we need to check if we can read prefs
  if (capable->smog_version_correct&&capable->can_write_to_tempdir==TRUE) {
    get_pref("recent1",buff,256);
  }
  mainw->recent1 = gtk_menu_item_new_with_label (buff);
  if (strlen (buff)) gtk_widget_show (mainw->recent1);
  if (capable->smog_version_correct&&capable->can_write_to_tempdir==TRUE) {
    get_pref("recent2",buff,256);
  }
  mainw->recent2 = gtk_menu_item_new_with_label (buff);
  if (strlen (buff)) gtk_widget_show (mainw->recent2);

  if (capable->smog_version_correct&&capable->can_write_to_tempdir==TRUE) {
    get_pref("recent3",buff,256);
  }
  mainw->recent3 = gtk_menu_item_new_with_label (buff);
  if (strlen (buff)) gtk_widget_show (mainw->recent3);

  if (capable->smog_version_correct&&capable->can_write_to_tempdir==TRUE) {
    get_pref("recent4",buff,256);
  }
  mainw->recent4 = gtk_menu_item_new_with_label (buff);
  if (strlen (buff)) gtk_widget_show (mainw->recent4);

  gtk_container_add (GTK_CONTAINER (mainw->recent_submenu), mainw->recent1);
  gtk_container_add (GTK_CONTAINER (mainw->recent_submenu), mainw->recent2);
  gtk_container_add (GTK_CONTAINER (mainw->recent_submenu), mainw->recent3);
  gtk_container_add (GTK_CONTAINER (mainw->recent_submenu), mainw->recent4);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(mainw->recent_submenu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }
  
  gtk_widget_show (mainw->recent_submenu);

  if (prefs->show_recent==TRUE) {
    gtk_widget_show (mainw->recent_menu);
  }

  separatormenuitem11 = gtk_menu_item_new ();
  gtk_widget_show (separatormenuitem11);
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), separatormenuitem11);
  gtk_widget_set_sensitive (separatormenuitem11, FALSE);

  mainw->save = gtk_image_menu_item_new_from_stock ("gtk-save", mainw->accel_group);
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->save);
  gtk_widget_set_sensitive (mainw->save, FALSE);

  mainw->save_as = gtk_image_menu_item_new_from_stock ("gtk-save-as", mainw->accel_group);
  gtk_container_add (GTK_CONTAINER(menuitem11_menu), mainw->save_as);
  gtk_widget_set_sensitive (mainw->save_as, FALSE);

  mainw->save_selection = gtk_menu_item_new_with_mnemonic (_("Sa_ve Selection As..."));
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->save_selection);
  gtk_widget_set_sensitive (mainw->save_selection, FALSE);

  if (capable->has_mencoder||capable->has_ffmpeg) {
    gtk_widget_show (mainw->save);
    gtk_widget_show (mainw->save_as);
    gtk_widget_show (mainw->save_selection);
  }

  mainw->close = gtk_menu_item_new_with_mnemonic (_("_Close"));
  gtk_widget_add_accelerator (mainw->close, "activate", mainw->accel_group,
                              GDK_w, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_show (mainw->close);
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->close);
  gtk_widget_set_sensitive (mainw->close, FALSE);

  separatormenuitem99 = gtk_menu_item_new ();
  gtk_widget_show (separatormenuitem99);
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), separatormenuitem99);
  gtk_widget_set_sensitive (separatormenuitem99, FALSE);

  mainw->backup = gtk_menu_item_new_with_mnemonic ("_Backup as .lv1...");
  gtk_widget_show (mainw->backup);
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->backup);
  gtk_widget_set_sensitive (mainw->backup, FALSE);

  gtk_widget_add_accelerator (mainw->backup, "activate", mainw->accel_group,
                              GDK_b, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  mainw->restore = gtk_menu_item_new_with_mnemonic ("_Restore .lv1...");
  gtk_widget_show (mainw->restore);
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->restore);

  gtk_widget_add_accelerator (mainw->restore, "activate", mainw->accel_group,
                              GDK_r, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  separatormenuitem2 = gtk_menu_item_new ();
  gtk_widget_show (separatormenuitem2);
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), separatormenuitem2);
  gtk_widget_set_sensitive (separatormenuitem2, FALSE);

  mainw->sw_sound = gtk_check_menu_item_new_with_mnemonic ("Save/Load/Backup _with Sound");
  gtk_widget_show (mainw->sw_sound);
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->sw_sound);
  gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(mainw->sw_sound),TRUE);

  separatormenuitem3 = gtk_menu_item_new ();
  gtk_widget_show (separatormenuitem3);
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), separatormenuitem3);
  gtk_widget_set_sensitive (separatormenuitem3, FALSE);

  mainw->quit = gtk_image_menu_item_new_from_stock ("gtk-quit", mainw->accel_group);
  gtk_widget_show (mainw->quit);
  gtk_container_add (GTK_CONTAINER (menuitem11_menu), mainw->quit);

  menuitem12 = gtk_menu_item_new_with_mnemonic ("_Edit");
  gtk_widget_show (menuitem12);
  gtk_container_add (GTK_CONTAINER (mainw->menubar), menuitem12);

  menuitem12_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem12), menuitem12_menu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(menuitem12_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->undo = gtk_image_menu_item_new_with_mnemonic ("_Undo");
  gtk_widget_show (mainw->undo);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->undo);
  gtk_widget_set_sensitive (mainw->undo, FALSE);

  gtk_widget_add_accelerator (mainw->undo, "activate", mainw->accel_group,
                              GDK_u, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  image333 = gtk_image_new_from_stock ("gtk-undo", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image333);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->undo), image333);

  mainw->redo = gtk_image_menu_item_new_with_mnemonic ("_Redo");
  gtk_widget_show (mainw->redo);
  gtk_widget_hide (mainw->redo);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->redo);
  gtk_widget_set_sensitive (mainw->redo, FALSE);

  gtk_widget_add_accelerator (mainw->redo, "activate", mainw->accel_group,
                              GDK_z, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  image380 = gtk_image_new_from_stock ("gtk-redo", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image380);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->redo), image380);

  separator3 = gtk_menu_item_new ();
  gtk_widget_show (separator3);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), separator3);
  gtk_widget_set_sensitive (separator3, FALSE);

  mainw->copy = gtk_image_menu_item_new_with_mnemonic ("_Copy Selection");
  gtk_widget_show (mainw->copy);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->copy);
  gtk_widget_set_sensitive (mainw->copy, FALSE);

  gtk_widget_add_accelerator (mainw->copy, "activate", mainw->accel_group,
                              GDK_c, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  mainw->cut = gtk_image_menu_item_new_with_mnemonic ("Cu_t Selection");
  gtk_widget_show (mainw->cut);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->cut);
  gtk_widget_set_sensitive (mainw->cut, FALSE);

  gtk_widget_add_accelerator (mainw->cut, "activate", mainw->accel_group,
                              GDK_t, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  mainw->insert = gtk_image_menu_item_new_with_mnemonic ("_Insert from Clipboard...");
  gtk_widget_show (mainw->insert);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->insert);
  gtk_widget_set_sensitive (mainw->insert, FALSE);

  gtk_widget_add_accelerator (mainw->insert, "activate", mainw->accel_group,
                              GDK_i, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  image334 = gtk_image_new_from_stock ("gtk-add", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image334);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->insert), image334);

  mainw->paste_as_new = gtk_image_menu_item_new_with_mnemonic ("Paste as _New");
  gtk_widget_show (mainw->paste_as_new);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->paste_as_new);
  gtk_widget_set_sensitive (mainw->paste_as_new, FALSE);

  gtk_widget_add_accelerator (mainw->paste_as_new, "activate", mainw->accel_group,
                              GDK_n, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  mainw->merge = gtk_menu_item_new_with_mnemonic ("_Merge Clipboard with Selection...");
  if (capable->has_composite&&capable->has_convert) {
    gtk_widget_show (mainw->merge);
  }
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->merge);
  gtk_widget_set_sensitive (mainw->merge, FALSE);

  gtk_widget_add_accelerator (mainw->merge, "activate", mainw->accel_group,
                              GDK_m, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  mainw->delete = gtk_image_menu_item_new_with_mnemonic(_("_Delete Selection"));
  gtk_widget_show (mainw->delete);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->delete);
  gtk_widget_set_sensitive (mainw->delete, FALSE);

  image1334 = gtk_image_new_from_stock ("gtk-delete", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image1334);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->delete), image1334);

  gtk_widget_add_accelerator (mainw->delete, "activate", mainw->accel_group,
                              GDK_d, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  separator5 = gtk_menu_item_new ();
  gtk_widget_show (separator5);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), separator5);
  gtk_widget_set_sensitive (separator5, FALSE);

  mainw->ccpd_sound = gtk_check_menu_item_new_with_mnemonic ("Decouple _Video from Audio");
  gtk_widget_show (mainw->ccpd_sound);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->ccpd_sound);
  gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(mainw->ccpd_sound),TRUE);

  separator55 = gtk_menu_item_new ();
  gtk_widget_show (separator55);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), separator55);
  gtk_widget_set_sensitive (separator55, FALSE);

  mainw->select_submenu = gtk_menu_item_new_with_mnemonic ("_Select...");
  gtk_widget_show (mainw->select_submenu);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->select_submenu);
  gtk_widget_set_sensitive(mainw->select_submenu,FALSE);

  select_submenu_menu=gtk_menu_new();

  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainw->select_submenu), select_submenu_menu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(select_submenu_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->select_all = gtk_menu_item_new_with_mnemonic ("Select _All Frames");
  gtk_widget_show (mainw->select_all);
  gtk_container_add (GTK_CONTAINER (select_submenu_menu), mainw->select_all);

  gtk_widget_add_accelerator (mainw->select_all, "activate", mainw->accel_group,
                              GDK_a, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  mainw->select_start_only = gtk_image_menu_item_new_with_mnemonic ("_Start Frame Only");
  gtk_widget_show (mainw->select_start_only);
  gtk_container_add (GTK_CONTAINER (select_submenu_menu), mainw->select_start_only);

  gtk_widget_add_accelerator (mainw->select_start_only, "activate", mainw->accel_group,
			      GDK_Home, GDK_CONTROL_MASK,
			      GTK_ACCEL_VISIBLE);

  mainw->select_end_only = gtk_image_menu_item_new_with_mnemonic ("_End Frame Only");
  gtk_widget_show (mainw->select_end_only);
  gtk_container_add (GTK_CONTAINER (select_submenu_menu), mainw->select_end_only);
  gtk_widget_add_accelerator (mainw->select_end_only, "activate", mainw->accel_group,
			      GDK_End, GDK_CONTROL_MASK,
			      GTK_ACCEL_VISIBLE);


  separatormenuitem110 = gtk_menu_item_new ();
  gtk_widget_show (separatormenuitem110);
  gtk_container_add (GTK_CONTAINER (select_submenu_menu), separatormenuitem110);
  gtk_widget_set_sensitive (separatormenuitem110,FALSE);
    
  mainw->select_from_start = gtk_image_menu_item_new_with_mnemonic ("Select from _First Frame");
  gtk_widget_show (mainw->select_from_start);
  gtk_container_add (GTK_CONTAINER (select_submenu_menu), mainw->select_from_start);

  mainw->select_to_end = gtk_image_menu_item_new_with_mnemonic ("Select to _Last Frame");
  gtk_container_add (GTK_CONTAINER (select_submenu_menu), mainw->select_to_end);
  gtk_widget_show (mainw->select_to_end);

  mainw->select_new = gtk_image_menu_item_new_with_mnemonic ("Select Last Insertion/_Merge");
  gtk_widget_show (mainw->select_new);
  gtk_container_add (GTK_CONTAINER (select_submenu_menu), mainw->select_new);

  mainw->select_last = gtk_image_menu_item_new_with_mnemonic ("Select Last _Effect");
  gtk_widget_show (mainw->select_last);
  gtk_container_add (GTK_CONTAINER (select_submenu_menu), mainw->select_last);

  mainw->select_invert = gtk_image_menu_item_new_with_mnemonic ("_Invert Selection");
  gtk_widget_show (mainw->select_invert);
  gtk_container_add (GTK_CONTAINER (select_submenu_menu), mainw->select_invert);

  gtk_widget_add_accelerator (mainw->select_invert, "activate", mainw->accel_group,
                              GDK_slash, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  mainw->lock_selwidth = gtk_check_menu_item_new_with_mnemonic ("_Lock Selection Width");
  gtk_widget_show (mainw->lock_selwidth);
  gtk_container_add (GTK_CONTAINER (menuitem12_menu), mainw->lock_selwidth);
  gtk_widget_set_sensitive(mainw->lock_selwidth,FALSE);

  menuitem13 = gtk_menu_item_new_with_mnemonic ("_Play");
  gtk_widget_show (menuitem13);
  gtk_container_add (GTK_CONTAINER (mainw->menubar), menuitem13);
  
  menuitem13_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem13), menuitem13_menu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(menuitem13_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->playall = gtk_image_menu_item_new_with_mnemonic (_("_Play All"));
  gtk_widget_add_accelerator (mainw->playall, "activate", mainw->accel_group,
                              GDK_p, 0,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_show (mainw->playall);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->playall);
  gtk_widget_set_sensitive (mainw->playall, FALSE);

  mainw->record = gtk_image_menu_item_new_with_mnemonic (_("_Record External Window"));
  gtk_widget_hide (mainw->record);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->record);

  image335 = gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image335);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->playall), image335);

  mainw->playsel = gtk_image_menu_item_new_with_mnemonic (_("Pla_y Selection"));
  gtk_widget_add_accelerator (mainw->playsel, "activate", mainw->accel_group,
                              GDK_y, 0,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_show (mainw->playsel);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->playsel);
  gtk_widget_set_sensitive (mainw->playsel, FALSE);

  mainw->playclip = gtk_image_menu_item_new_with_mnemonic (_("Play _Clipboard"));
  gtk_widget_show (mainw->playclip);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->playclip);
  gtk_widget_set_sensitive (mainw->playclip, FALSE);

  gtk_widget_add_accelerator (mainw->playclip, "activate", mainw->accel_group,
                              GDK_c, 0,
                              GTK_ACCEL_VISIBLE);


  image336 = gtk_image_new_from_stock ("gtk-go-forward", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image336);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->playsel), image336);
  image355 = gtk_image_new_from_stock ("gtk-go-forward", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image355);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->playclip), image355);

  mainw->stop = gtk_image_menu_item_new_with_mnemonic (_("_Stop"));
  gtk_widget_show (mainw->stop);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->stop);
  gtk_widget_set_sensitive (mainw->stop, FALSE);
  gtk_widget_add_accelerator (mainw->stop, "activate", mainw->accel_group,
                              GDK_q, 0,
                              GTK_ACCEL_VISIBLE);


  image337 = gtk_image_new_from_stock ("gtk-stop", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image337);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->stop), image337);

  mainw->rewind = gtk_image_menu_item_new_with_mnemonic (_("Re_wind"));
  gtk_widget_show (mainw->rewind);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->rewind);
  gtk_widget_set_sensitive (mainw->rewind, FALSE);

  image1337 = gtk_image_new_from_stock ("gtk-back", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image1337);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->rewind), image1337);

  gtk_widget_add_accelerator (mainw->rewind, "activate", mainw->accel_group,
                              GDK_w, 0,
                              GTK_ACCEL_VISIBLE);

  mainw->record_perf = gtk_check_menu_item_new_with_mnemonic (_("_Record/Clear Performance"));

  gtk_widget_set_sensitive (mainw->record_perf, FALSE);

  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->record_perf);
  gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(mainw->record_perf),FALSE);

  separator8 = gtk_menu_item_new ();
  gtk_widget_show (separator8);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), separator8);
  gtk_widget_set_sensitive (separator8, FALSE);

  mainw->full_screen = gtk_check_menu_item_new_with_mnemonic (_("_Full Screen"));
  gtk_widget_show (mainw->full_screen);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->full_screen);


  gtk_widget_add_accelerator (mainw->full_screen, "activate", mainw->accel_group,
                              GDK_f, 0,
                              GTK_ACCEL_VISIBLE);

  mainw->dsize = gtk_check_menu_item_new_with_mnemonic (_("_Double Size"));
  gtk_widget_show (mainw->dsize);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->dsize);

  gtk_widget_add_accelerator (mainw->dsize, "activate", mainw->accel_group,
                              GDK_d, 0,
                              GTK_ACCEL_VISIBLE);

  mainw->sepwin = gtk_check_menu_item_new_with_mnemonic (_("Play in _Separate Window"));
  gtk_widget_show (mainw->sepwin);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->sepwin);

  gtk_widget_add_accelerator (mainw->sepwin, "activate", mainw->accel_group,
                              GDK_s, 0,
                              GTK_ACCEL_VISIBLE);


  mainw->fade = gtk_check_menu_item_new_with_mnemonic (_("_Blank Background"));
  gtk_widget_add_accelerator (mainw->fade, "activate", mainw->accel_group,
                              GDK_b, 0,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_show (mainw->fade);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->fade);

  mainw->loop_video = gtk_check_menu_item_new_with_mnemonic (_("(Auto)_loop Video (to fit audio track)"));
  gtk_widget_show (mainw->loop_video);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->loop_video);
  gtk_widget_set_sensitive (mainw->loop_video, FALSE);
  gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(mainw->loop_video),TRUE);
  gtk_widget_add_accelerator (mainw->loop_video, "activate", mainw->accel_group,
                              GDK_l, 0,
                              GTK_ACCEL_VISIBLE);

  mainw->loop_continue = gtk_check_menu_item_new_with_mnemonic (_("L_oop Continuously"));
  gtk_widget_show (mainw->loop_continue);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->loop_continue);
  gtk_widget_set_sensitive (mainw->loop_continue, FALSE);

  gtk_widget_add_accelerator (mainw->loop_continue, "activate", mainw->accel_group,
                              GDK_o, 0,
                              GTK_ACCEL_VISIBLE);

  mainw->loop_ping_pong = gtk_check_menu_item_new_with_mnemonic (_("Pin_g Pong Loops"));
  gtk_widget_show (mainw->loop_ping_pong);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->loop_ping_pong);

  gtk_widget_add_accelerator (mainw->loop_ping_pong, "activate", mainw->accel_group,
                              GDK_g, 0,
                              GTK_ACCEL_VISIBLE);

  mainw->mute_audio = gtk_check_menu_item_new_with_mnemonic (_("_Mute"));
  gtk_widget_show (mainw->mute_audio);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->mute_audio);
  gtk_widget_set_sensitive (mainw->mute_audio, FALSE);

  gtk_widget_add_accelerator (mainw->mute_audio, "activate", mainw->accel_group,
                              GDK_m, 0,
                              GTK_ACCEL_VISIBLE);

  separator49 = gtk_menu_item_new ();
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), separator49);
  gtk_widget_set_sensitive (separator49, FALSE);
  gtk_widget_show (separator49);

  mainw->sticky = gtk_check_menu_item_new_with_mnemonic (_("Separate _Window 'Sticky' Mode"));
  gtk_widget_show (mainw->sticky);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->sticky);
  if (prefs->sepwin_type==1) {
    gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(mainw->sticky),TRUE);
  }

  mainw->showfct = gtk_check_menu_item_new_with_mnemonic (_("S_how Frame Counter"));
  gtk_widget_show (mainw->showfct);
  gtk_container_add (GTK_CONTAINER (menuitem13_menu), mainw->showfct);

  gtk_widget_add_accelerator (mainw->showfct, "activate", mainw->accel_group,
                              GDK_h, 0,
                              GTK_ACCEL_VISIBLE);


  gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(mainw->showfct),prefs->show_framecount);

  if (prefs->video_player==VID_PLAYER_MPLAYER) {
    // mplayer can't do sticky windows, because it destroys the window by itself
    gtk_widget_set_sensitive (mainw->sticky,FALSE);
    gtk_widget_set_sensitive (mainw->showfct,FALSE);
    gtk_widget_set_sensitive (mainw->loop_ping_pong,FALSE);
  }

  effects = gtk_menu_item_new_with_mnemonic ("Effect_s");
  gtk_widget_show (effects);
  gtk_container_add (GTK_CONTAINER (mainw->menubar), effects);

  effects_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (effects), effects_menu);

  if (capable->has_mogrify==FALSE||capable->has_convert==FALSE) {
    gtk_widget_set_sensitive(effects_menu,FALSE);
  }

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(effects_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->realtime_fx = gtk_image_menu_item_new_with_mnemonic ("_Apply Current Realtime FX");
  gtk_widget_show (mainw->realtime_fx);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->realtime_fx);
  gtk_widget_set_sensitive (mainw->realtime_fx, FALSE);
  gtk_tooltips_set_tip (mainw->tooltips, mainw->realtime_fx,"See: VJ - show VJ keys. Set the realtime effects, and then apply them here.", NULL);

  gtk_widget_add_accelerator (mainw->realtime_fx, "activate", mainw->accel_group,
                              GDK_e, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  separator77 = gtk_menu_item_new ();
  gtk_widget_show (separator77);
  gtk_container_add (GTK_CONTAINER (effects_menu), separator77);
  gtk_widget_set_sensitive (separator77, FALSE);

  mainw->monochrome = gtk_image_menu_item_new_with_mnemonic (_("_Black and White"));
  gtk_widget_show (mainw->monochrome);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->monochrome);
  gtk_widget_set_sensitive (mainw->monochrome, FALSE);

  image348 = gtk_image_new_from_stock ("gtk-no", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image348);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->monochrome), image348);

  mainw->blank_frames = gtk_image_menu_item_new_with_mnemonic (_("_Blank Frames"));
  gtk_widget_show (mainw->blank_frames);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->blank_frames);
  gtk_widget_set_sensitive (mainw->blank_frames, FALSE);

  image520 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image520);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->blank_frames), image520);

  mainw->charcoal = gtk_image_menu_item_new_with_mnemonic (_("_Charcoal"));
  gtk_widget_show (mainw->charcoal);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->charcoal);
  gtk_widget_set_sensitive (mainw->charcoal, FALSE);

  image400 = gtk_image_new_from_stock ("gtk-no", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image400);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->charcoal), image400);

  mainw->colour_cycle = gtk_image_menu_item_new_with_mnemonic (_("Co_lour Cycle"));
  gtk_widget_show (mainw->colour_cycle);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->colour_cycle);
  gtk_widget_set_sensitive (mainw->colour_cycle, FALSE);

  image339 = gtk_image_new_from_stock ("gtk-no", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image339);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->colour_cycle), image339);

  mainw->colour_filter = gtk_image_menu_item_new_with_mnemonic (_("Colour Filter..."));
  gtk_widget_show (mainw->colour_filter);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->colour_filter);
  gtk_widget_set_sensitive (mainw->colour_filter, FALSE);

  image515 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image515);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->colour_filter), image515);

  mainw->colorize = gtk_image_menu_item_new_with_mnemonic (_("Colori_ze..."));
  gtk_widget_show (mainw->colorize);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->colorize);
  gtk_widget_set_sensitive (mainw->colorize, FALSE);

  image340 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image340);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->colorize), image340);

  mainw->dream = gtk_image_menu_item_new_with_mnemonic ("_Dream");
  gtk_widget_show (mainw->dream);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->dream);
  gtk_widget_set_sensitive (mainw->dream, FALSE);

  image571 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image571);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->dream), image571);

  mainw->edge_detect = gtk_image_menu_item_new_with_mnemonic (_("Edge _Detect"));
  gtk_widget_show (mainw->edge_detect);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->edge_detect);
  gtk_widget_set_sensitive (mainw->edge_detect, FALSE);

  image341 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image341);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->edge_detect), image341);

  mainw->enhance = gtk_image_menu_item_new_with_mnemonic (_("_Enhance"));
  gtk_widget_show (mainw->enhance);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->enhance);
  gtk_widget_set_sensitive (mainw->enhance, FALSE);

  image381 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image381);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->enhance), image381);

  mainw->flop = gtk_image_menu_item_new_with_mnemonic ("Flip _Horizontally");
  gtk_widget_show (mainw->flop);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->flop);
  gtk_widget_set_sensitive (mainw->flop, FALSE);

  image511 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image511);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->flop), image511);

  mainw->flip = gtk_image_menu_item_new_with_mnemonic ("Flip _Vertically");
  gtk_widget_show (mainw->flip);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->flip);
  gtk_widget_set_sensitive (mainw->flip, FALSE);

  image512 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image512);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->flip), image512);

  mainw->jumble = gtk_image_menu_item_new_with_mnemonic ("_Jumble Frames");
  gtk_widget_show (mainw->jumble);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->jumble);
  gtk_widget_set_sensitive (mainw->jumble, FALSE);

  image513 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image513);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->jumble), image513);

  mainw->negate = gtk_image_menu_item_new_with_mnemonic (_("_Negate/Strobe..."));
  gtk_widget_show (mainw->negate);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->negate);
  gtk_widget_set_sensitive (mainw->negate, FALSE);

  image342 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image342);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->negate), image342);

  mainw->normalize = gtk_image_menu_item_new_with_mnemonic (_("N_ormalize"));
  gtk_widget_show (mainw->normalize);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->normalize);
  gtk_widget_set_sensitive (mainw->normalize, FALSE);

  image501 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image501);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->normalize), image501);

  mainw->randomzoom = gtk_image_menu_item_new_with_mnemonic ("R_andom Zoom");
  gtk_widget_show (mainw->randomzoom);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->randomzoom);
  gtk_widget_set_sensitive (mainw->randomzoom, FALSE);

  image404 = gtk_image_new_from_stock ("gtk-no", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image404);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->randomzoom), image404);

  mainw->transx = gtk_image_menu_item_new_with_mnemonic (_("Shift Horizontally (_x)..."));
  gtk_widget_show (mainw->transx);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->transx);
  gtk_widget_set_sensitive (mainw->transx, FALSE);

  image406 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image406);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->transx), image406);

  mainw->transy = gtk_image_menu_item_new_with_mnemonic (_("Shift Vertically (_y)..."));
  gtk_widget_show (mainw->transy);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->transy);
  gtk_widget_set_sensitive (mainw->transy, FALSE);

  image407 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image407);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->transy), image407);

  mainw->shrink = gtk_image_menu_item_new_with_mnemonic (_("S_hrink/Expand"));
  gtk_widget_show (mainw->shrink);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->shrink);
  gtk_widget_set_sensitive (mainw->shrink, FALSE);

  image405 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image405);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->shrink), image405);

  mainw->solarize = gtk_image_menu_item_new_with_mnemonic (_("S_olarize"));
  gtk_widget_show (mainw->solarize);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->solarize);
  gtk_widget_set_sensitive (mainw->solarize, FALSE);

  image403 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image403);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->solarize), image403);

  mainw->rotate = gtk_image_menu_item_new_with_mnemonic (_("_Spin..."));
  gtk_widget_show (mainw->rotate);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->rotate);
  gtk_widget_set_sensitive (mainw->rotate, FALSE);

  image402 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image402);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->rotate), image402);

  mainw->swirl = gtk_image_menu_item_new_with_mnemonic (_("_Swirl"));
  gtk_widget_show (mainw->swirl);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->swirl);
  gtk_widget_set_sensitive (mainw->swirl, FALSE);

  image343 = gtk_image_new_from_stock ("gtk-no", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image343);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->swirl), image343);
  
  mainw->tunnel = gtk_image_menu_item_new_with_mnemonic ("_Tunnel");
  gtk_widget_show (mainw->tunnel);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->tunnel);
  gtk_widget_set_sensitive (mainw->tunnel, FALSE);

  image514 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image514);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->tunnel), image514);

  mainw->wave = gtk_image_menu_item_new_with_mnemonic ("_Wave");
  gtk_widget_show (mainw->wave);
  gtk_container_add (GTK_CONTAINER (effects_menu), mainw->wave);
  gtk_widget_set_sensitive (mainw->wave, FALSE);

  image510 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image510);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->wave), image510);
  
  _quick = gtk_image_menu_item_new_with_mnemonic (_("= quick"));
  gtk_widget_show (_quick);
  gtk_container_add (GTK_CONTAINER (effects_menu), _quick);
  gtk_widget_set_sensitive (_quick, FALSE);

  image344 = gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image344);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (_quick), image344);

  _slow = gtk_image_menu_item_new_with_mnemonic (_("= slow"));
  gtk_widget_show (_slow);
  gtk_container_add (GTK_CONTAINER (effects_menu), _slow);
  gtk_widget_set_sensitive (_slow, FALSE);

  image345 = gtk_image_new_from_stock ("gtk-no", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image345);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (_slow), image345);

  tools = gtk_menu_item_new_with_mnemonic (_("_Tools"));
  gtk_widget_show (tools);
  gtk_container_add (GTK_CONTAINER (mainw->menubar), tools);

  tools_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (tools), tools_menu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(tools_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->rev_clipboard = gtk_menu_item_new_with_mnemonic ("_Reverse Clipboard");
  gtk_widget_show (mainw->rev_clipboard);
  gtk_container_add (GTK_CONTAINER (tools_menu), mainw->rev_clipboard);
  gtk_widget_set_sensitive (mainw->rev_clipboard, FALSE);

  gtk_widget_add_accelerator (mainw->rev_clipboard, "activate", mainw->accel_group,
                              GDK_x, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  mainw->change_speed = gtk_menu_item_new_with_mnemonic ("_Change Playback/Save Speed...");
  gtk_widget_show (mainw->change_speed);
  gtk_container_add (GTK_CONTAINER (tools_menu), mainw->change_speed);
  gtk_widget_set_sensitive (mainw->change_speed, FALSE);

  mainw->resize = gtk_menu_item_new_with_mnemonic (_("Re_size All Frames..."));

  if (capable->has_mogrify==TRUE) {
    gtk_widget_show (mainw->resize);
  }

  gtk_container_add (GTK_CONTAINER (tools_menu), mainw->resize);
  gtk_widget_set_sensitive (mainw->resize, FALSE);

  mainw->trim_frames = gtk_menu_item_new_with_mnemonic (_("Tri_m Frame Size..."));

  if (capable->has_mogrify==TRUE) {
    gtk_widget_show (mainw->trim_frames);
  }

  gtk_container_add (GTK_CONTAINER (tools_menu), mainw->trim_frames);
  gtk_widget_set_sensitive (mainw->trim_frames, FALSE);

  mainw->rotate_all = gtk_menu_item_new_with_mnemonic (_("Ro_tate Clip..."));
  gtk_widget_show (mainw->rotate_all);
  gtk_container_add (GTK_CONTAINER (tools_menu), mainw->rotate_all);
  gtk_widget_set_sensitive (mainw->rotate_all, FALSE);

  separator26 = gtk_menu_item_new ();
  gtk_widget_show (separator26);
  gtk_container_add (GTK_CONTAINER (tools_menu), separator26);
  gtk_widget_set_sensitive (separator26, FALSE);

  mainw->resample_video = gtk_menu_item_new_with_mnemonic ("Resample _Video at New Frame Rate...");
  gtk_widget_show (mainw->resample_video);
  gtk_container_add (GTK_CONTAINER (tools_menu), mainw->resample_video);
  gtk_widget_set_sensitive (mainw->resample_video, FALSE);

  mainw->capture = gtk_menu_item_new_with_mnemonic ("Capture _External Window... ");
  gtk_widget_show (mainw->capture);
  gtk_container_add (GTK_CONTAINER (tools_menu), mainw->capture);

  mainw->reorder = gtk_menu_item_new_with_mnemonic ("Reorder _Frames (to match performance)");
  gtk_widget_show (mainw->reorder);
  gtk_container_add (GTK_CONTAINER (tools_menu), mainw->reorder);
  gtk_widget_set_sensitive (mainw->reorder, FALSE);

  separator6 = gtk_menu_item_new ();
  gtk_widget_show (separator6);
  gtk_container_add (GTK_CONTAINER (tools_menu), separator6);
  gtk_widget_set_sensitive (separator6, FALSE);

  mainw->preferences = gtk_image_menu_item_new_with_mnemonic ("_Preferences...");
  gtk_widget_show (mainw->preferences);
  gtk_container_add (GTK_CONTAINER (tools_menu), mainw->preferences);
  gtk_widget_add_accelerator (mainw->preferences, "activate", mainw->accel_group,
                              GDK_p, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  image346 = gtk_image_new_from_stock ("gtk-preferences", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image346);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->preferences), image346);

  audio = gtk_menu_item_new_with_mnemonic ("_Audio");
  gtk_widget_show (audio);
  gtk_container_add (GTK_CONTAINER (mainw->menubar), audio);

  audio_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (audio), audio_menu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(audio_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->load_audio = gtk_menu_item_new_with_mnemonic ("Load _New Audio for Clip...");

  gtk_widget_show (mainw->load_audio);
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->load_audio);
  gtk_widget_set_sensitive (mainw->load_audio, FALSE);


  mainw->load_cdtrack = gtk_menu_item_new_with_mnemonic ("Load _CD Track...");
  mainw->eject_cd = gtk_menu_item_new_with_mnemonic ("E_ject CD");
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->load_cdtrack);
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->eject_cd);

  gtk_widget_set_sensitive (mainw->load_cdtrack, FALSE);
  gtk_widget_set_sensitive (mainw->eject_cd, FALSE);

  gtk_widget_show (mainw->eject_cd);
  gtk_widget_show (mainw->load_cdtrack);

  separator9 = gtk_menu_item_new ();
  gtk_container_add (GTK_CONTAINER (audio_menu), separator9);
  gtk_widget_set_sensitive (separator9, FALSE);
  
  mainw->export_submenu = gtk_menu_item_new_with_mnemonic ("_Export Audio...");
  gtk_widget_show (mainw->export_submenu);
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->export_submenu);
  gtk_widget_set_sensitive(mainw->export_submenu,FALSE);

  export_submenu_menu=gtk_menu_new();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainw->export_submenu), export_submenu_menu);
  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(export_submenu_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }
  gtk_widget_show (mainw->export_submenu);

  mainw->export_selaudio = gtk_menu_item_new_with_mnemonic ("Export _Selected Audio...");
  gtk_widget_show (mainw->export_selaudio);
  gtk_container_add (GTK_CONTAINER (export_submenu_menu), mainw->export_selaudio);

  mainw->export_allaudio = gtk_menu_item_new_with_mnemonic ("Export _All Audio...");
  gtk_widget_show (mainw->export_allaudio);
  gtk_container_add (GTK_CONTAINER (export_submenu_menu), mainw->export_allaudio);

  mainw->append_audio = gtk_menu_item_new_with_mnemonic ("_Append Audio...");
  gtk_widget_show (mainw->append_audio);
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->append_audio);
  gtk_widget_set_sensitive (mainw->append_audio, FALSE);

  mainw->trim_submenu = gtk_menu_item_new_with_mnemonic ("_Trim Audio...");
  gtk_widget_show (mainw->trim_submenu);
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->trim_submenu);
  gtk_widget_set_sensitive(mainw->trim_submenu,FALSE);

  trimaudio_submenu_menu=gtk_menu_new();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainw->trim_submenu), trimaudio_submenu_menu);
  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(trimaudio_submenu_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }
  gtk_widget_show (mainw->trim_submenu);
  mainw->trim_audio = gtk_menu_item_new_with_mnemonic ("Trim Audio to _Selection");
  gtk_widget_show (mainw->trim_audio);
  gtk_container_add (GTK_CONTAINER (trimaudio_submenu_menu), mainw->trim_audio);

  mainw->trim_to_pstart = gtk_menu_item_new_with_mnemonic ("Trim Audio from Beginning to _Play Start");
  gtk_widget_show (mainw->trim_to_pstart);
  gtk_container_add (GTK_CONTAINER (trimaudio_submenu_menu), mainw->trim_to_pstart);
  gtk_widget_set_sensitive (mainw->trim_to_pstart, FALSE);

  mainw->delaudio_submenu = gtk_menu_item_new_with_mnemonic ("_Delete Audio...");
  gtk_widget_show (mainw->delaudio_submenu);
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->delaudio_submenu);
  gtk_widget_set_sensitive(mainw->delaudio_submenu,FALSE);

  delaudio_submenu_menu=gtk_menu_new();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainw->delaudio_submenu), delaudio_submenu_menu);
  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(delaudio_submenu_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }
  gtk_widget_show (mainw->delaudio_submenu);

  mainw->delsel_audio = gtk_menu_item_new_with_mnemonic ("Delete _Selected Audio");
  gtk_widget_show (mainw->delsel_audio);
  gtk_container_add (GTK_CONTAINER (delaudio_submenu_menu), mainw->delsel_audio);

  mainw->delall_audio = gtk_menu_item_new_with_mnemonic ("Delete _All Audio");
  gtk_widget_show (mainw->delall_audio);
  gtk_container_add (GTK_CONTAINER (delaudio_submenu_menu), mainw->delall_audio);

  mainw->ins_silence = gtk_menu_item_new_with_mnemonic ("_Insert Silence in Selection");
  gtk_widget_show (mainw->ins_silence);
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->ins_silence);
  gtk_widget_set_sensitive (mainw->ins_silence, FALSE);

  mainw->resample_audio = gtk_menu_item_new_with_mnemonic ("_Resample Audio...");
  gtk_widget_show (mainw->resample_audio);
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->resample_audio);
  gtk_widget_set_sensitive (mainw->resample_audio, FALSE);

  separator19 = gtk_menu_item_new ();
  gtk_container_add (GTK_CONTAINER (audio_menu), separator19);
  gtk_widget_set_sensitive (separator19, FALSE);
  gtk_widget_show (separator19);

  mainw->xmms_play_audio = gtk_menu_item_new_with_mnemonic (_("Play _Music Using xmms..."));
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->xmms_play_audio);
  gtk_widget_set_sensitive (mainw->xmms_play_audio, TRUE);

  mainw->xmms_random_audio = gtk_menu_item_new_with_mnemonic (_("Random Music _Using xmms..."));
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->xmms_random_audio);
  gtk_widget_set_sensitive (mainw->xmms_random_audio, TRUE);

  mainw->xmms_stop_audio = gtk_menu_item_new_with_mnemonic (_("_Stop xmms Playing"));
  gtk_container_add (GTK_CONTAINER (audio_menu), mainw->xmms_stop_audio);
  gtk_widget_set_sensitive (mainw->xmms_stop_audio, TRUE);
  
  gtk_widget_show (mainw->xmms_stop_audio);
  gtk_widget_show (mainw->xmms_play_audio);
  gtk_widget_show (mainw->xmms_random_audio);
  gtk_widget_show (separator9);
  
  if (!capable->has_xmms) {
    gtk_widget_set_sensitive (mainw->xmms_stop_audio,FALSE);
    gtk_widget_set_sensitive (mainw->xmms_play_audio,FALSE);
    gtk_widget_set_sensitive (mainw->xmms_random_audio,FALSE);
  }

  info = gtk_menu_item_new_with_mnemonic (_("_Info"));
  gtk_widget_show (info);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), info);

  info_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (info), info_menu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(info_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->show_file_info = gtk_image_menu_item_new_with_mnemonic (_("Show File _Info"));
  gtk_widget_add_accelerator (mainw->show_file_info, "activate", mainw->accel_group,
                              GDK_i, 0,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_show (mainw->show_file_info);
  gtk_container_add (GTK_CONTAINER (info_menu), mainw->show_file_info);
  gtk_widget_set_sensitive (mainw->show_file_info, FALSE);

  mainw->show_file_comments = gtk_image_menu_item_new_with_mnemonic (_("Show/_Edit File Comments"));
  gtk_widget_show (mainw->show_file_comments);
  gtk_container_add (GTK_CONTAINER (info_menu), mainw->show_file_comments);
  gtk_widget_set_sensitive (mainw->show_file_comments, FALSE);

  mainw->show_clipboard_info = gtk_image_menu_item_new_with_mnemonic (_("Show _Clipboard Info"));
  gtk_widget_show (mainw->show_clipboard_info);
  gtk_container_add (GTK_CONTAINER (info_menu), mainw->show_clipboard_info);
  gtk_widget_set_sensitive (mainw->show_clipboard_info, FALSE);

  image347 = gtk_image_new_from_stock ("gtk-dialog-info", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image347);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (mainw->show_file_info), image347);

  win = gtk_menu_item_new_with_mnemonic (_("_Clips"));
  gtk_widget_show (win);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), win);

  mainw->winmenu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (win), mainw->winmenu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(mainw->winmenu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->rename = gtk_image_menu_item_new_with_mnemonic ("_Rename Current Clip in Menu...");
  gtk_widget_show (mainw->rename);
  gtk_container_add (GTK_CONTAINER (mainw->winmenu), mainw->rename);
  gtk_widget_set_sensitive (mainw->rename, FALSE);

  separator10 = gtk_menu_item_new ();
  gtk_widget_show (separator10);
  gtk_container_add (GTK_CONTAINER (mainw->winmenu), separator10);
  gtk_widget_set_sensitive (separator10, FALSE);

  menuitemsep = gtk_menu_item_new_with_label ("         |         ");
  gtk_widget_show (menuitemsep);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), menuitemsep);
  gtk_widget_set_sensitive (menuitemsep,FALSE);

  mainw->vj_menu = gtk_menu_item_new_with_mnemonic (_("_VJ"));
  gtk_widget_show (mainw->vj_menu);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), mainw->vj_menu);

  vj_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainw->vj_menu), vj_menu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(vj_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  mainw->vj_save_set = gtk_menu_item_new_with_mnemonic (_("_Save Set and Exit"));
  gtk_widget_show (mainw->vj_save_set);
  gtk_container_add (GTK_CONTAINER (vj_menu), mainw->vj_save_set);
  gtk_widget_set_sensitive (mainw->vj_save_set, FALSE);

  mainw->vj_load_set = gtk_menu_item_new_with_mnemonic (_("_Reload Set"));
  gtk_widget_show (mainw->vj_load_set);
  gtk_container_add (GTK_CONTAINER (vj_menu), mainw->vj_load_set);

  separator88 = gtk_menu_item_new ();
  gtk_widget_show (separator88);
  gtk_container_add (GTK_CONTAINER (vj_menu), separator88);
  gtk_widget_set_sensitive (separator88, FALSE);

  mainw->vj_show_keys = gtk_menu_item_new_with_mnemonic (_("Show VJ _Keys"));
  gtk_widget_show (mainw->vj_show_keys);
  gtk_container_add (GTK_CONTAINER (vj_menu), mainw->vj_show_keys);

  mainw->toys = gtk_menu_item_new_with_mnemonic (_("To_ys"));
  gtk_widget_show (mainw->toys);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), mainw->toys);

  toys_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainw->toys), toys_menu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(toys_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }


  mainw->toy_none = gtk_check_menu_item_new_with_mnemonic (_("_None"));
  gtk_widget_show (mainw->toy_none);
  gtk_container_add (GTK_CONTAINER (toys_menu), mainw->toy_none);
  gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(mainw->toy_none),TRUE);

  separator27 = gtk_menu_item_new ();
  gtk_widget_show (separator27);
  gtk_container_add (GTK_CONTAINER (toys_menu), separator27);
  gtk_widget_set_sensitive (separator27, FALSE);

  mainw->toy_random_frames = gtk_check_menu_item_new_with_mnemonic (_("_Mad Frames"));
  gtk_widget_show (mainw->toy_random_frames);
  gtk_container_add (GTK_CONTAINER (toys_menu), mainw->toy_random_frames);
  gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(mainw->toy_random_frames),FALSE);

  mainw->toy_tv = gtk_menu_item_new_with_mnemonic (_("_LiVES TV (broadband)"));


  gtk_container_add (GTK_CONTAINER (toys_menu), mainw->toy_tv);

#ifdef LIVES_TV_CHANNEL1
  gtk_widget_show (mainw->toy_tv);
#else
  gtk_widget_hide (mainw->toy_tv);
# endif

  menuitem14 = gtk_menu_item_new_with_mnemonic (_("_Help"));
  gtk_widget_show (menuitem14);
  gtk_container_add (GTK_CONTAINER (mainw->menubar), menuitem14);

  menuitem14_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem14), menuitem14_menu);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_bg(menuitem14_menu, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  about = gtk_menu_item_new_with_mnemonic (_("_About"));
  gtk_widget_show (about);
  gtk_container_add (GTK_CONTAINER (menuitem14_menu), about);

  menuitemsep2 = gtk_menu_item_new_with_label ("         |         ");
  gtk_widget_show (menuitemsep2);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), menuitemsep2);
  gtk_widget_set_sensitive (menuitemsep2,FALSE);

  // menu buttons
  mainw->m_rewindbutton = gtk_menu_item_new ();
  g_snprintf (buff,256,"%s%s/rewind.png",prefs->prefix_dir,ICON_DIR);
  rewind_img=gtk_image_new_from_file (buff);
  rewindbutton=gtk_button_new();
  gtk_widget_modify_bg (rewindbutton, GTK_STATE_ACTIVE, &palette->menu_and_bars);
  gtk_widget_set_size_request (rewindbutton, 28, 18);
  gtk_button_set_relief (GTK_BUTTON (rewindbutton), GTK_RELIEF_NONE);
  gtk_container_add (GTK_CONTAINER(rewindbutton), rewind_img);
  gtk_container_add (GTK_CONTAINER(mainw->m_rewindbutton), rewindbutton);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), mainw->m_rewindbutton);
  gtk_widget_show (mainw->m_rewindbutton);
  gtk_widget_show (rewind_img);
  gtk_widget_show (rewindbutton);
  gtk_tooltips_set_tip (mainw->tooltips, mainw->m_rewindbutton,"Rewind", NULL);
  gtk_widget_set_sensitive (mainw->m_rewindbutton, FALSE);

  mainw->m_playbutton = gtk_menu_item_new ();
  g_snprintf (buff,256,"%s%s/play.png",prefs->prefix_dir,ICON_DIR);
  play_img=gtk_image_new_from_file (buff);
  playbutton=gtk_button_new();
  gtk_widget_modify_bg (playbutton, GTK_STATE_ACTIVE, &palette->menu_and_bars);
  gtk_widget_set_size_request (playbutton, 28, 18);
  gtk_button_set_relief (GTK_BUTTON (playbutton), GTK_RELIEF_NONE);
  gtk_container_add (GTK_CONTAINER(playbutton), play_img);
  gtk_container_add (GTK_CONTAINER(mainw->m_playbutton), playbutton);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), mainw->m_playbutton);
  gtk_widget_show (mainw->m_playbutton);
  gtk_widget_show (play_img);
  gtk_widget_show (playbutton);
  gtk_tooltips_set_tip (mainw->tooltips, mainw->m_playbutton,"Play", NULL);
  gtk_widget_set_sensitive (mainw->m_playbutton, FALSE);

  mainw->m_stopbutton = gtk_menu_item_new ();
  g_snprintf (buff,256,"%s%s/stop.png",prefs->prefix_dir,ICON_DIR);
  stop_img=gtk_image_new_from_file (buff);
  stopbutton=gtk_button_new();
  gtk_widget_modify_bg (stopbutton, GTK_STATE_ACTIVE, &palette->menu_and_bars);
  gtk_widget_set_size_request (stopbutton, 28, 18);
  gtk_button_set_relief (GTK_BUTTON (stopbutton), GTK_RELIEF_NONE);
  gtk_container_add (GTK_CONTAINER(stopbutton), stop_img);
  gtk_container_add (GTK_CONTAINER(mainw->m_stopbutton), stopbutton);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), mainw->m_stopbutton);
  gtk_widget_show (mainw->m_stopbutton);
  gtk_widget_show (stop_img);
  gtk_widget_show (stopbutton);
  gtk_tooltips_set_tip (mainw->tooltips, mainw->m_stopbutton,"Stop", NULL);
  gtk_widget_set_sensitive (mainw->m_stopbutton, FALSE);

  mainw->m_playselbutton = gtk_menu_item_new ();
  g_snprintf (buff,256,"%s%s/playsel.png",prefs->prefix_dir,ICON_DIR);
  playsel_img=gtk_image_new_from_file (buff);
  playselbutton=gtk_button_new();
  gtk_widget_modify_bg (playselbutton, GTK_STATE_ACTIVE, &palette->menu_and_bars);
  gtk_widget_set_size_request (playselbutton, 28, 18);
  gtk_button_set_relief (GTK_BUTTON (playselbutton), GTK_RELIEF_NONE);
  gtk_container_add (GTK_CONTAINER(playselbutton), playsel_img);
  gtk_container_add (GTK_CONTAINER(mainw->m_playselbutton), playselbutton);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), mainw->m_playselbutton);
  gtk_widget_show (mainw->m_playselbutton);
  gtk_widget_show (playsel_img);
  gtk_widget_show (playselbutton);
  gtk_tooltips_set_tip (mainw->tooltips, mainw->m_playselbutton,"Play Selection", NULL);
  gtk_widget_set_sensitive (mainw->m_playselbutton, FALSE);

  mainw->m_loopbutton = gtk_menu_item_new ();
  g_snprintf (buff,256,"%s%s/loop.png",prefs->prefix_dir,ICON_DIR);
  loop_img=gtk_image_new_from_file (buff);
  loopbutton=gtk_button_new();
  gtk_widget_modify_bg (loopbutton, GTK_STATE_ACTIVE, &palette->menu_and_bars);
  gtk_widget_set_size_request (loopbutton, 28, 18);
  gtk_button_set_relief (GTK_BUTTON (loopbutton), GTK_RELIEF_NONE);
  gtk_container_add (GTK_CONTAINER(loopbutton), loop_img);
  gtk_container_add (GTK_CONTAINER(mainw->m_loopbutton), loopbutton);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), mainw->m_loopbutton);
  gtk_widget_show (mainw->m_loopbutton);
  gtk_widget_show (loop_img);
  gtk_widget_show (loopbutton);
  gtk_tooltips_set_tip (mainw->tooltips, mainw->m_loopbutton,"Loop On/Off", NULL);
  gtk_widget_set_sensitive (mainw->m_loopbutton, FALSE);

  mainw->m_mutebutton = gtk_menu_item_new ();
  g_snprintf (buff,256,"%s%s/volume.png",prefs->prefix_dir,ICON_DIR);
  mainw->mute_img=gtk_image_new_from_file (buff);
  mutebutton=gtk_button_new();
  gtk_widget_modify_bg (mutebutton, GTK_STATE_ACTIVE, &palette->menu_and_bars);
  gtk_widget_set_size_request (mutebutton, 28, 18);
  gtk_button_set_relief (GTK_BUTTON (mutebutton), GTK_RELIEF_NONE);
  gtk_container_add (GTK_CONTAINER(mutebutton), mainw->mute_img);
  gtk_container_add (GTK_CONTAINER(mainw->m_mutebutton), mutebutton);
  gtk_container_add (GTK_CONTAINER(mainw->menubar), mainw->m_mutebutton);
  gtk_widget_show (mainw->m_mutebutton);
  gtk_widget_show (mainw->mute_img);
  gtk_widget_show (mutebutton);
  gtk_tooltips_set_tip (mainw->tooltips, mainw->m_mutebutton,"Mute/Unmute", NULL);
  gtk_widget_set_sensitive (mainw->m_mutebutton, FALSE);

  // TODO - add volume slider


  mainw->play_window=NULL;

  mainw->toolbar = gtk_toolbar_new ();
  gtk_widget_hide (mainw->toolbar);

  gtk_box_pack_start (GTK_BOX (vbox1), mainw->toolbar, FALSE, FALSE, 0);

  gtk_toolbar_set_style (GTK_TOOLBAR (mainw->toolbar), GTK_TOOLBAR_ICONS);
  gtk_toolbar_set_icon_size (GTK_TOOLBAR(mainw->toolbar),GTK_ICON_SIZE_SMALL_TOOLBAR);
  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-stop", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));
  

  mainw->t_stopbutton = gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Stop",
                                "Stop Playback (q)" , NULL,
                                tmp_toolbar_icon, NULL, NULL);


  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-undo", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_bckground= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Unblank",
                                "Unblank Background (b)", NULL,
                                tmp_toolbar_icon, NULL, NULL);

  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-copy", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_sepwin= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Separate",
                                "Play in Separate Window (s)", NULL,
                                tmp_toolbar_icon, NULL, NULL);

  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-zoom-in", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_double= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Double",
                                "Double Size (d)", NULL,
                                tmp_toolbar_icon, NULL, NULL);

  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-zoom-out", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_single= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					       GTK_TOOLBAR_CHILD_BUTTON,
					       NULL,
					       "Single",
					       "Single Size (d)", NULL,
					       tmp_toolbar_icon, NULL, NULL);

  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-zoom-100", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_fullscreen= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Full Screen",
                                "Full Screen (f)", NULL,
                                tmp_toolbar_icon, NULL, NULL);

  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-remove", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_slower= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Slower",
                                "Play Slower (ctrl-down)", NULL,
                                tmp_toolbar_icon, NULL, NULL);

  gtk_widget_add_accelerator (mainw->t_slower, "clicked", mainw->accel_group,
                              GDK_Down, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-add", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_faster= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Faster",
                                "Play Faster (ctrl-up)", NULL,
                                tmp_toolbar_icon, NULL, NULL);

  gtk_widget_add_accelerator (mainw->t_faster, "clicked", mainw->accel_group,
                              GDK_Up, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-go-back", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_back = gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Skip back",
                                "Skip back (ctrl-left)", NULL,
                                tmp_toolbar_icon, NULL, NULL);

  gtk_widget_add_accelerator (mainw->t_back, "clicked", mainw->accel_group,
                              GDK_Left, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
 
  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-go-forward", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_forward = gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Skip Forward",
                                "Skip Forward (ctrl-right)", NULL,
                                tmp_toolbar_icon, NULL, NULL);

  gtk_widget_add_accelerator (mainw->t_forward, "clicked", mainw->accel_group,
                              GDK_Right, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-dialog-info", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_infobutton= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Info",
                                "Show File Info (i)", NULL,
                                tmp_toolbar_icon, NULL, NULL);


  // invisible 'buttons'
  mainw->t_dirchange= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
						  GTK_TOOLBAR_CHILD_BUTTON,
						  NULL,
						  "Change direction",
						  "Change Direction", NULL,
						  NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_dirchange);

  gtk_widget_add_accelerator (mainw->t_dirchange, "clicked", mainw->accel_group,
                              GDK_space, GDK_CONTROL_MASK,
                              0);

  mainw->t_freeze= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
						  GTK_TOOLBAR_CHILD_BUTTON,
						  NULL,
						  "Freeze",
						  "Freeze/Unfreeze", NULL,
						  NULL, NULL, NULL);


  gtk_widget_hide(mainw->t_freeze);

  mainw->t_grabkeys= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
						 GTK_TOOLBAR_CHILD_BUTTON,
						 NULL,
						 "Grab keys",
						 "Grab 3 keys for last effect", NULL,
						 NULL, NULL, NULL);


  gtk_widget_hide(mainw->t_grabkeys);

  gtk_widget_add_accelerator (mainw->t_grabkeys, "clicked", mainw->accel_group,
                              GDK_k, 0,
                              0);

  mainw->t_rtemode= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
						GTK_TOOLBAR_CHILD_BUTTON,
						NULL,
						"Switch RTE_mode",
						"Realtime FX mode switch", NULL,
						NULL, NULL, NULL);


  gtk_widget_hide(mainw->t_rtemode);

  gtk_widget_add_accelerator (mainw->t_rtemode, "clicked", mainw->accel_group,
                              GDK_x, 0,
                              0);

  mainw->t_f1= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 1",
					   "Store/retrieve sample 1", NULL,
					   NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_f1);

  gtk_widget_add_accelerator (mainw->t_f1, "clicked", mainw->accel_group,
                              GDK_F1, 0,
                              0);
  mainw->t_f2= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 2",
					   "Store/retrieve sample 2", NULL,
					   NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_f2);

  gtk_widget_add_accelerator (mainw->t_f2, "clicked", mainw->accel_group,
                              GDK_F2, 0,
                              0);
  mainw->t_f3= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 3",
					   "Store/retrieve sample 3", NULL,
					   NULL, NULL, NULL);
  gtk_widget_hide(mainw->t_f3);


  gtk_widget_add_accelerator (mainw->t_f3, "clicked", mainw->accel_group,
                              GDK_F3, 0,
                              0);
  mainw->t_f4= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 4",
					   "Store/retrieve sample 4", NULL,
					   NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_f4);

  gtk_widget_add_accelerator (mainw->t_f4, "clicked", mainw->accel_group,
                              GDK_F4, 0,
                              0);
  mainw->t_f5= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 5",
					   "Store/retrieve sample 5", NULL,
					   NULL, NULL, NULL);


  gtk_widget_add_accelerator (mainw->t_f5, "clicked", mainw->accel_group,
                              GDK_F5, 0,
                              0);
  gtk_widget_hide(mainw->t_f5);

  mainw->t_f6= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 6",
					   "Store/retrieve sample 6", NULL,
					   NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_f6);

  gtk_widget_add_accelerator (mainw->t_f6, "clicked", mainw->accel_group,
                              GDK_F6, 0,
                              0);
  mainw->t_f7= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 7",
					   "Store/retrieve sample 7", NULL,
					   NULL, NULL, NULL);
  gtk_widget_hide(mainw->t_f7);


  gtk_widget_add_accelerator (mainw->t_f7, "clicked", mainw->accel_group,
                              GDK_F7, 0,
                              0);
  mainw->t_f8= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 8",
					   "Store/retrieve sample 8", NULL,
					   NULL, NULL, NULL);
  gtk_widget_hide(mainw->t_f8);


  gtk_widget_add_accelerator (mainw->t_f8, "clicked", mainw->accel_group,
                              GDK_F8, 0,
                              0);
  mainw->t_f9= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 9",
					   "Store/retrieve sample 9", NULL,
					   NULL, NULL, NULL);
  gtk_widget_hide(mainw->t_f9);


  gtk_widget_add_accelerator (mainw->t_f9, "clicked", mainw->accel_group,
                              GDK_F9, 0,
                              0);
  mainw->t_f10= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 10",
					   "Store/retrieve sample 10", NULL,
					   NULL, NULL, NULL);
  gtk_widget_hide(mainw->t_f10);


  gtk_widget_add_accelerator (mainw->t_f10, "clicked", mainw->accel_group,
                              GDK_F10, 0,
                              0);
  mainw->t_f11= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 11",
					   "Store/retrieve sample 11", NULL,
					   NULL, NULL, NULL);
  gtk_widget_hide(mainw->t_f11);


  gtk_widget_add_accelerator (mainw->t_f11, "clicked", mainw->accel_group,
                              GDK_F11, 0,
                              0);
  mainw->t_f12= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					   GTK_TOOLBAR_CHILD_BUTTON,
					   NULL,
					   "Store 12",
					   "Store/retrieve sample 12", NULL,
					   NULL, NULL, NULL);
  gtk_widget_hide(mainw->t_f12);


  gtk_widget_add_accelerator (mainw->t_f12, "clicked", mainw->accel_group,
                              GDK_F12, 0,
                              0);

  mainw->t_nextclip= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
						  GTK_TOOLBAR_CHILD_BUTTON,
						  NULL,
						  "Next clip",
						  "Next clip", NULL,
						  NULL, NULL, NULL);
  gtk_widget_hide(mainw->t_nextclip);


  gtk_widget_add_accelerator (mainw->t_nextclip, "clicked", mainw->accel_group,
                              GDK_Page_Down, GDK_CONTROL_MASK,
                              0);

  mainw->t_prevclip= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
						  GTK_TOOLBAR_CHILD_BUTTON,
						  NULL,
						  "Prev clip",
						  "Prev clip", NULL,
						  NULL, NULL, NULL);
  gtk_widget_hide(mainw->t_prevclip);


  gtk_widget_add_accelerator (mainw->t_prevclip, "clicked", mainw->accel_group,
                              GDK_Page_Up, GDK_CONTROL_MASK,
                              0);

  mainw->t_nervous= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
						  GTK_TOOLBAR_CHILD_BUTTON,
						  NULL,
						  "Nervous",
						  "Nervous", NULL,
						  NULL, NULL, NULL);

  mainw->t_rte1= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Effect 1",
					     "Real time effect 1", NULL,
					     NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_rte1);

  gtk_widget_add_accelerator (mainw->t_rte1, "clicked", mainw->accel_group,
                              GDK_1, GDK_CONTROL_MASK,
                              0);


  mainw->t_rte2= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Effect 2",
					     "Real time effect 2", NULL,
					     NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_rte2);

  gtk_widget_add_accelerator (mainw->t_rte2, "clicked", mainw->accel_group,
                              GDK_2, GDK_CONTROL_MASK,
                              0);


  mainw->t_rte3= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Effect 3",
					     "Real time effect 3", NULL,
					     NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_rte3);

  gtk_widget_add_accelerator (mainw->t_rte3, "clicked", mainw->accel_group,
                              GDK_3, GDK_CONTROL_MASK,
                              0);


  mainw->t_rte4= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Effect 4",
					     "Real time effect 4", NULL,
					     NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_rte4);

  gtk_widget_add_accelerator (mainw->t_rte4, "clicked", mainw->accel_group,
                              GDK_4, GDK_CONTROL_MASK,
                              0);


  mainw->t_rte5= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Effect 5",
					     "Real time effect 5", NULL,
					     NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_rte5);

  gtk_widget_add_accelerator (mainw->t_rte5, "clicked", mainw->accel_group,
                              GDK_5, GDK_CONTROL_MASK,
                              0);

  mainw->t_rte6= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Effect 6",
					     "Real time effect 6", NULL,
					     NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_rte6);

  gtk_widget_add_accelerator (mainw->t_rte6, "clicked", mainw->accel_group,
                              GDK_6, GDK_CONTROL_MASK,
                              0);

  mainw->t_rte7= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Effect 7",
					     "Real time effect 7", NULL,
					     NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_rte7);

  gtk_widget_add_accelerator (mainw->t_rte7, "clicked", mainw->accel_group,
                              GDK_7, GDK_CONTROL_MASK,
                              0);

  mainw->t_rte8= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Effect 8",
					     "Real time effect 8", NULL,
					     NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_rte8);

  gtk_widget_add_accelerator (mainw->t_rte8, "clicked", mainw->accel_group,
                              GDK_8, GDK_CONTROL_MASK,
                              0);


  mainw->t_rte9= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Effect 9",
					     "Real time effect 9", NULL,
					     NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_rte9);

  gtk_widget_add_accelerator (mainw->t_rte9, "clicked", mainw->accel_group,
                              GDK_9, GDK_CONTROL_MASK,
                              0);


  mainw->t_rte0= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Effect Off",
					     "Real time effect off", NULL,
					     NULL, NULL, NULL);

  gtk_widget_hide(mainw->t_rte0);

  gtk_widget_add_accelerator (mainw->t_rte0, "clicked", mainw->accel_group,
                              GDK_0, GDK_CONTROL_MASK,
                              0);

  gtk_widget_hide(mainw->t_nervous);

  gtk_widget_add_accelerator (mainw->t_nervous, "clicked", mainw->accel_group,
                              GDK_n, 0,
                              0);

  t_label=gtk_label_new("   Use ctrl and <-- arrows --> to move through the clip. Press 'r' before playing to record your changes.");
  gtk_widget_show(t_label);
  
  t_label = gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
                                GTK_TOOLBAR_CHILD_WIDGET,
                                t_label,
                                NULL,
                                NULL, NULL,
                                NULL, NULL, NULL);


  gtk_toolbar_append_space (GTK_TOOLBAR (mainw->toolbar));

  tmp_toolbar_icon = gtk_image_new_from_stock ("gtk-cancel", gtk_toolbar_get_icon_size (GTK_TOOLBAR (mainw->toolbar)));

  mainw->t_hide= gtk_toolbar_append_element (GTK_TOOLBAR (mainw->toolbar),
					     GTK_TOOLBAR_CHILD_BUTTON,
					     NULL,
					     "Info",
					     "Hide this toolbar", NULL,
					     tmp_toolbar_icon, NULL, NULL);

  gtk_widget_modify_bg (mainw->t_hide, GTK_STATE_NORMAL, &palette->normal_back);

  gtk_widget_show (mainw->t_stopbutton);
  gtk_widget_show (mainw->t_bckground);
  gtk_widget_show (mainw->t_sepwin);
  gtk_widget_show (mainw->t_double);
  gtk_widget_hide (mainw->t_single);
  gtk_widget_show (mainw->t_fullscreen);
  gtk_widget_show (mainw->t_slower);
  gtk_widget_show (mainw->t_faster);
  gtk_widget_show (mainw->t_forward);
  gtk_widget_show (mainw->t_back);
  gtk_widget_show (mainw->t_infobutton);
  gtk_widget_show (mainw->t_hide);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);

  mainw->eventbox = gtk_event_box_new ();
  gtk_widget_show (mainw->eventbox);
  gtk_box_pack_start (GTK_BOX (vbox1), mainw->eventbox, TRUE, TRUE, 0);
  gtk_container_add (GTK_CONTAINER (mainw->eventbox), vbox4);

  mainw->framebar = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (mainw->framebar);
  gtk_box_pack_start (GTK_BOX (vbox4), mainw->framebar, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (mainw->framebar), 2);

  mainw->vps_label = gtk_label_new ("     Video playback speed (frames per second)        ");
  gtk_widget_show (mainw->vps_label);
  gtk_box_pack_start (GTK_BOX (mainw->framebar), mainw->vps_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (mainw->vps_label), GTK_JUSTIFY_LEFT);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_fg(mainw->vps_label, GTK_STATE_NORMAL, &palette->normal_fore);
  }

  spinbutton_pb_fps_adj = gtk_adjustment_new (1, -FPS_MAX, FPS_MAX, 0.1, 0.01, 0.01);
  mainw->spinbutton_pb_fps = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_pb_fps_adj), 0, 3);
  gtk_widget_show (mainw->spinbutton_pb_fps);
  gtk_box_pack_start (GTK_BOX (mainw->framebar), mainw->spinbutton_pb_fps, FALSE, TRUE, 0);
  gtk_tooltips_set_tip (mainw->tooltips, mainw->spinbutton_pb_fps,"Vary the video speed", NULL);

  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (mainw->spinbutton_pb_fps), TRUE);


  if (palette->style==STYLE_PLAIN) {
    mainw->banner = gtk_label_new ("             = <  L i V E S > =                ");
  }
  else {
    mainw->banner = gtk_label_new ("                                                ");
  }
  gtk_widget_show (mainw->banner);

  gtk_box_pack_start (GTK_BOX (mainw->framebar), mainw->banner, TRUE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (mainw->banner), GTK_JUSTIFY_CENTER);

  mainw->framecounter = gtk_entry_new ();
  gtk_widget_show (mainw->framecounter);
  gtk_box_pack_start (GTK_BOX (mainw->framebar), mainw->framecounter, FALSE, TRUE, 0);
  gtk_entry_set_editable (GTK_ENTRY (mainw->framecounter), FALSE);
  gtk_entry_set_has_frame (GTK_ENTRY (mainw->framecounter), FALSE);
  gtk_entry_set_width_chars (GTK_ENTRY (mainw->framecounter), 18);
  GTK_WIDGET_UNSET_FLAGS (mainw->framecounter, GTK_CAN_FOCUS);

  mainw->curf_label = gtk_label_new (_("                                                            "));
  gtk_widget_show (mainw->curf_label);
  gtk_box_pack_start (GTK_BOX (mainw->framebar), mainw->curf_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (mainw->curf_label), GTK_JUSTIFY_LEFT);
  if (palette->style&STYLE_1) {
    gtk_widget_modify_fg(mainw->curf_label, GTK_STATE_NORMAL, &palette->normal_fore);
  }

  gtk_widget_hide(mainw->framebar);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox1, FALSE, FALSE, 0);
  gtk_widget_modify_bg (hbox1, GTK_STATE_NORMAL, &palette->normal_back);

  mainw->eventbox3 = gtk_event_box_new ();
  gtk_widget_show (mainw->eventbox3);
  gtk_box_pack_start (GTK_BOX (hbox1), mainw->eventbox3, TRUE, FALSE, 0);
  gtk_widget_modify_bg (mainw->eventbox3, GTK_STATE_NORMAL, &palette->normal_back);

  mainw->frame1 = gtk_frame_new (NULL);
  gtk_widget_show (mainw->frame1);
  gtk_container_add (GTK_CONTAINER (mainw->eventbox3), mainw->frame1);
  gtk_widget_modify_bg (mainw->frame1, GTK_STATE_NORMAL, &palette->normal_back);

  gtk_container_set_border_width (GTK_CONTAINER(mainw->eventbox3), 10);
  gtk_frame_set_shadow_type (GTK_FRAME(mainw->frame1), GTK_SHADOW_IN);

  gtk_widget_show (mainw->image272);
  gtk_container_add (GTK_CONTAINER (mainw->frame1), mainw->image272);

  label15 = gtk_label_new (_("First Frame"));
  gtk_widget_show (label15);
  gtk_frame_set_label_widget (GTK_FRAME (mainw->frame1), label15);
  gtk_label_set_justify (GTK_LABEL (label15), GTK_JUSTIFY_LEFT);
  if (palette->style&STYLE_1) {
    gtk_widget_modify_fg(label15, GTK_STATE_NORMAL, &palette->normal_fore);
  }

  mainw->playframe = gtk_frame_new (NULL);
  gtk_widget_hide (mainw->playframe);
  gtk_box_pack_start (GTK_BOX (hbox1), mainw->playframe, TRUE, FALSE, 0);
  gtk_widget_set_size_request (mainw->playframe, DEFAULT_FRAME_HSIZE, DEFAULT_FRAME_VSIZE);
  gtk_container_set_border_width (GTK_CONTAINER (mainw->playframe), 10);
  gtk_frame_set_shadow_type (GTK_FRAME(mainw->playframe), GTK_SHADOW_IN);
  gtk_widget_modify_bg (mainw->playframe, GTK_STATE_NORMAL, &palette->normal_back);

  pf_label = gtk_label_new (_("Play"));
  gtk_widget_show (pf_label);
  gtk_frame_set_label_widget (GTK_FRAME (mainw->playframe), pf_label);
  gtk_label_set_justify (GTK_LABEL (pf_label), GTK_JUSTIFY_LEFT);
  if (palette->style&STYLE_1) {
    gtk_widget_modify_fg(pf_label, GTK_STATE_NORMAL, &palette->normal_fore);
  }
  mainw->playarea = gtk_socket_new ();
  gtk_container_add (GTK_CONTAINER (mainw->playframe), mainw->playarea);

  gtk_widget_set_app_paintable(mainw->playarea,TRUE);

  mainw->eventbox4 = gtk_event_box_new ();
  gtk_box_pack_start (GTK_BOX (hbox1), mainw->eventbox4, TRUE, FALSE, 0);
  gtk_widget_modify_bg (mainw->eventbox4, GTK_STATE_NORMAL, &palette->normal_back);
  gtk_widget_show (mainw->eventbox4);

  mainw->frame2 = gtk_frame_new (NULL);
  gtk_widget_show (mainw->frame2);
  gtk_container_add (GTK_CONTAINER (mainw->eventbox4), mainw->frame2);
  gtk_widget_modify_bg (mainw->frame2, GTK_STATE_NORMAL, &palette->normal_back);

  gtk_container_set_border_width (GTK_CONTAINER(mainw->eventbox4), 10);
  gtk_frame_set_shadow_type (GTK_FRAME(mainw->frame2), GTK_SHADOW_IN);
  
  gtk_widget_show (mainw->image273);
  gtk_container_add (GTK_CONTAINER (mainw->frame2), mainw->image273);

  // default frame sizes
  mainw->def_width=DEFAULT_FRAME_HSIZE;
  mainw->def_height=DEFAULT_FRAME_HSIZE;

  if (!(mainw->imframe==NULL)) {
    if (gdk_pixbuf_get_width (mainw->imframe)+H_RESIZE_ADJUST<mainw->def_width) {
      mainw->def_width=gdk_pixbuf_get_width (mainw->imframe)+H_RESIZE_ADJUST;
    }
    if (gdk_pixbuf_get_height (mainw->imframe)+V_RESIZE_ADJUST<mainw->def_height) {
      mainw->def_height=gdk_pixbuf_get_height (mainw->imframe)+V_RESIZE_ADJUST;
    }
  }

  gtk_widget_set_size_request (mainw->eventbox3, mainw->def_width, mainw->def_height);
  gtk_widget_set_size_request (mainw->frame1, mainw->def_width, mainw->def_height);
  gtk_widget_set_size_request (mainw->frame2, mainw->def_width, mainw->def_height);
  gtk_widget_set_size_request (mainw->eventbox4, mainw->def_width, mainw->def_height);
  

  // the actual playback image for the internal player
  mainw->image274 = gtk_image_new_from_pixbuf (NULL);
  gtk_widget_show (mainw->image274);
  gtk_widget_ref(mainw->image274);
  gtk_object_sink (GTK_OBJECT (mainw->image274));

  label16 = gtk_label_new (_("Last Frame"));
  gtk_widget_show (label16);
  gtk_frame_set_label_widget (GTK_FRAME (mainw->frame2), label16);
  gtk_label_set_justify (GTK_LABEL (label16), GTK_JUSTIFY_RIGHT);
  if (palette->style&STYLE_1) {
    gtk_widget_modify_fg(label16, GTK_STATE_NORMAL, &palette->normal_fore);
  }
  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox3, FALSE, TRUE, 0);

  spinbutton_start_adj = gtk_adjustment_new (0, 0, 0, 1, 100, 10);
  mainw->spinbutton_start = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_start_adj), 1, 0);

  gtk_widget_show (mainw->spinbutton_start);
  gtk_box_pack_start (GTK_BOX (hbox3), mainw->spinbutton_start, TRUE, FALSE, 76);
  GTK_WIDGET_SET_FLAGS (mainw->spinbutton_start, GTK_CAN_DEFAULT|GTK_CAN_FOCUS);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (mainw->spinbutton_start), TRUE);
  gtk_spin_button_set_update_policy (GTK_SPIN_BUTTON (mainw->spinbutton_start),GTK_UPDATE_IF_VALID);

  mainw->arrow1 = gtk_arrow_new (GTK_ARROW_LEFT, GTK_SHADOW_OUT);
  gtk_widget_show (mainw->arrow1);
  gtk_box_pack_start (GTK_BOX (hbox3), mainw->arrow1, FALSE, FALSE, 0);
  gtk_widget_modify_fg(mainw->arrow1, GTK_STATE_NORMAL, &palette->normal_fore);

  gtk_entry_set_width_chars (GTK_ENTRY (mainw->spinbutton_start),8);
  mainw->sel_label = gtk_label_new(NULL);

  set_sel_label();
  gtk_widget_show (mainw->sel_label);
  gtk_box_pack_start (GTK_BOX (hbox3), mainw->sel_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (mainw->sel_label), GTK_JUSTIFY_LEFT);
  gtk_widget_modify_fg(mainw->sel_label, GTK_STATE_NORMAL, &palette->normal_fore);

  mainw->arrow2 = gtk_arrow_new (GTK_ARROW_RIGHT, GTK_SHADOW_OUT);
  gtk_widget_show (mainw->arrow2);
  gtk_box_pack_start (GTK_BOX (hbox3), mainw->arrow2, FALSE, FALSE, 0);
  gtk_widget_modify_fg(mainw->arrow2, GTK_STATE_NORMAL, &palette->normal_fore);

  spinbutton_end_adj = gtk_adjustment_new (0, 0, 0, 1, 100, 10);
  mainw->spinbutton_end = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_end_adj), 1, 0);
  gtk_widget_show (mainw->spinbutton_end);
  gtk_box_pack_start (GTK_BOX (hbox3), mainw->spinbutton_end, TRUE, FALSE, 76);
  gtk_entry_set_width_chars (GTK_ENTRY (mainw->spinbutton_end),8);
  GTK_WIDGET_SET_FLAGS (mainw->spinbutton_end, GTK_CAN_DEFAULT|GTK_CAN_FOCUS);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (mainw->spinbutton_end), TRUE);
  gtk_spin_button_set_update_policy (GTK_SPIN_BUTTON (mainw->spinbutton_end),GTK_UPDATE_IF_VALID);

  if (palette->style&STYLE_1&&palette->style&STYLE_2) {
    gtk_widget_modify_base(mainw->spinbutton_start, GTK_STATE_NORMAL, &palette->normal_back);
    gtk_widget_modify_base(mainw->spinbutton_start, GTK_STATE_INSENSITIVE, &palette->normal_back);
    gtk_widget_modify_base(mainw->spinbutton_end, GTK_STATE_NORMAL, &palette->normal_back);
    gtk_widget_modify_base(mainw->spinbutton_end, GTK_STATE_INSENSITIVE, &palette->normal_back);
    gtk_widget_modify_text(mainw->spinbutton_start, GTK_STATE_NORMAL, &palette->normal_fore);
    gtk_widget_modify_text(mainw->spinbutton_start, GTK_STATE_INSENSITIVE, &palette->normal_fore);
    gtk_widget_modify_text(mainw->spinbutton_end, GTK_STATE_NORMAL, &palette->normal_fore);
    gtk_widget_modify_text(mainw->spinbutton_end, GTK_STATE_INSENSITIVE, &palette->normal_fore);
    gtk_widget_modify_fg(mainw->sel_label, GTK_STATE_NORMAL, &palette->normal_fore);
  }

  gtk_widget_set_sensitive(mainw->spinbutton_start,FALSE);
  gtk_widget_set_sensitive(mainw->spinbutton_end,FALSE);

  mainw->hseparator = gtk_hseparator_new ();

  if (palette->style&STYLE_1) {
    gtk_box_pack_start (GTK_BOX (vbox4), mainw->sep_image, FALSE, TRUE, 20);
    gtk_widget_show (mainw->sep_image);
  }

  else {
    gtk_box_pack_start (GTK_BOX (vbox4), mainw->hseparator, TRUE, TRUE, 0);
    gtk_widget_show (mainw->hseparator);
  }

  mainw->eventbox5 = gtk_event_box_new ();
  gtk_box_pack_start (GTK_BOX (vbox4), mainw->eventbox5, FALSE, FALSE, 0);
  gtk_widget_set_events (mainw->eventbox5, GDK_BUTTON1_MOTION_MASK | GDK_BUTTON_RELEASE | GDK_BUTTON_PRESS);

  mainw->hruler = gtk_hruler_new();
  gtk_ruler_set_range (GTK_RULER (mainw->hruler), 0., 10., 0., 10.);
  gtk_widget_set_size_request (mainw->hruler, -1, 20);
  gtk_widget_modify_bg (mainw->hruler, GTK_STATE_NORMAL, &palette->normal_back);
  gtk_widget_set_events (mainw->eventbox5, GDK_POINTER_MOTION_MASK | GDK_BUTTON1_MOTION_MASK | GDK_BUTTON_RELEASE | GDK_BUTTON_PRESS);
  gtk_container_add (GTK_CONTAINER (mainw->eventbox5), mainw->hruler);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_fg (mainw->hruler, GTK_STATE_NORMAL, &palette->normal_fore);
  }

  mainw->eventbox2 = gtk_event_box_new ();
  gtk_widget_show (mainw->eventbox2);
  gtk_box_pack_start (GTK_BOX (vbox4), mainw->eventbox2, TRUE, TRUE, 0);
  gtk_widget_set_events (mainw->eventbox2, GDK_BUTTON1_MOTION_MASK | GDK_BUTTON_RELEASE | GDK_BUTTON_PRESS);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (mainw->eventbox2), vbox2);

  mainw->vidbar = gtk_label_new (_("Video"));

  if (palette->style==STYLE_PLAIN) {
    gtk_widget_show (mainw->vidbar);
  }
  else {
    gtk_widget_modify_fg (mainw->vidbar, GTK_STATE_NORMAL, &palette->normal_fore);
    gtk_widget_hide (mainw->vidbar);
  }

  gtk_label_set_justify (GTK_LABEL (mainw->vidbar), GTK_JUSTIFY_LEFT);
  gtk_box_pack_start (GTK_BOX (vbox2), mainw->vidbar, TRUE, TRUE, 0);

  mainw->video_draw = gtk_drawing_area_new ();
  gtk_drawing_area_size(GTK_DRAWING_AREA(mainw->video_draw),mainw->LiVES->allocation.width,10);
  gtk_widget_show (mainw->video_draw);
  gtk_box_pack_start (GTK_BOX (vbox2), mainw->video_draw, TRUE, TRUE, 0);
  gtk_widget_modify_bg (mainw->video_draw, GTK_STATE_NORMAL, &palette->normal_back);

  mainw->laudbar = gtk_label_new (_("Left Audio"));
  gtk_box_pack_start (GTK_BOX (vbox2), mainw->laudbar, TRUE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (mainw->laudbar), GTK_JUSTIFY_LEFT);

  if (palette->style==STYLE_PLAIN) {
    gtk_widget_show (mainw->laudbar);
  }
  else {
    gtk_widget_modify_fg (mainw->laudbar, GTK_STATE_NORMAL, &palette->normal_fore);
    gtk_widget_hide (mainw->laudbar);
  }

  mainw->laudio_draw = gtk_drawing_area_new ();
  gtk_drawing_area_size(GTK_DRAWING_AREA(mainw->laudio_draw),mainw->LiVES->allocation.width,10);
  gtk_widget_show (mainw->laudio_draw);
  gtk_box_pack_start (GTK_BOX (vbox2), mainw->laudio_draw, TRUE, TRUE, 0);
  gtk_widget_modify_bg (mainw->laudio_draw, GTK_STATE_NORMAL, &palette->normal_back);

  mainw->raudbar = gtk_label_new (_("Right Audio"));
  gtk_box_pack_start (GTK_BOX (vbox2), mainw->raudbar, TRUE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (mainw->raudbar), GTK_JUSTIFY_LEFT);

  if (palette->style==STYLE_PLAIN) {
    gtk_widget_show (mainw->raudbar);
  }
  else {
    gtk_widget_modify_fg (mainw->raudbar, GTK_STATE_NORMAL, &palette->normal_fore);
    gtk_widget_hide (mainw->raudbar);
  }

  mainw->raudio_draw = gtk_drawing_area_new ();
  gtk_drawing_area_size(GTK_DRAWING_AREA(mainw->raudio_draw),mainw->LiVES->allocation.width,10);
  gtk_widget_show (mainw->raudio_draw);
  gtk_box_pack_start (GTK_BOX (vbox2), mainw->raudio_draw, TRUE, TRUE, 0);
  gtk_widget_modify_bg (mainw->raudio_draw, GTK_STATE_NORMAL, &palette->normal_back);


  mainw->scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (mainw->scrolledwindow);
  gtk_box_pack_start (GTK_BOX (vbox4), mainw->scrolledwindow, TRUE, TRUE, 0);

  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(mainw->scrolledwindow),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
  mainw->textview1 = gtk_text_view_new ();
  gtk_widget_show (mainw->textview1);
  gtk_container_add (GTK_CONTAINER (mainw->scrolledwindow), mainw->textview1);
  gtk_widget_set_size_request (mainw->textview1, -1, 50);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (mainw->textview1), FALSE);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (mainw->textview1), GTK_WRAP_WORD);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW (mainw->textview1), FALSE);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_base(mainw->textview1, GTK_STATE_NORMAL, &palette->info_base);
    gtk_widget_modify_text(mainw->textview1, GTK_STATE_NORMAL, &palette->info_text);
  }


  gtk_widget_modify_bg (mainw->eventbox, GTK_STATE_NORMAL, &palette->normal_back);
  gtk_widget_modify_bg (mainw->eventbox2, GTK_STATE_NORMAL, &palette->normal_back);

  gtk_text_buffer_set_text (gtk_text_view_get_buffer (GTK_TEXT_VIEW (mainw->textview1)),
	_("Starting...\n"), -1);
  
  g_signal_connect (GTK_OBJECT (mainw->LiVES), "delete_event",
		    G_CALLBACK (on_LiVES_delete_event),
		    NULL);

  mainw->config_func=g_signal_connect_after (GTK_OBJECT (mainw->video_draw), "configure_event",
					     G_CALLBACK (config_event),
					     NULL);
  mainw->vidbar_func=g_signal_connect_after (GTK_OBJECT (mainw->video_draw), "expose_event",
		    G_CALLBACK (expose_vid_event),
		    NULL);
  mainw->laudbar_func=g_signal_connect_after (GTK_OBJECT (mainw->laudio_draw), "expose_event",
		    G_CALLBACK (expose_laud_event),
		    NULL);
  mainw->raudbar_func=g_signal_connect_after (GTK_OBJECT (mainw->raudio_draw), "expose_event",
		    G_CALLBACK (expose_raud_event),
		    NULL);
  mainw->pb_fps_func=g_signal_connect_after (GTK_OBJECT (mainw->spinbutton_pb_fps), "value_changed",
                      G_CALLBACK (changed_fps_during_pb),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->open), "activate",
		    G_CALLBACK (on_open_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->open_sel), "activate",
		    G_CALLBACK (on_open_sel_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->open_dvd), "activate",
		    G_CALLBACK (on_open_vcd_activate),
		    GINT_TO_POINTER (1));
  g_signal_connect (GTK_OBJECT (mainw->open_vcd), "activate",
		    G_CALLBACK (on_open_vcd_activate),
		    GINT_TO_POINTER (2));
  g_signal_connect (GTK_OBJECT (mainw->open_loc), "activate",
		    G_CALLBACK (on_open_loc_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->open_firewire), "activate",
		    G_CALLBACK (on_open_fw_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->recent1), "activate",
                      G_CALLBACK (on_recent_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->recent2), "activate",
                      G_CALLBACK (on_recent_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->recent3), "activate",
                      G_CALLBACK (on_recent_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->recent4), "activate",
                      G_CALLBACK (on_recent_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->save), "activate",
                      G_CALLBACK (on_save_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->backup), "activate",
                      G_CALLBACK (on_backup_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->restore), "activate",
                      G_CALLBACK (on_restore_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->save_as), "activate",
		    G_CALLBACK (on_save_as_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->save_selection), "activate",
		    G_CALLBACK (on_save_selection_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->close), "activate",
                      G_CALLBACK (on_close_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->quit), "activate",
                      G_CALLBACK (on_quit_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->undo), "activate",
                      G_CALLBACK (on_undo_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->redo), "activate",
                      G_CALLBACK (on_redo_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->copy), "activate",
                      G_CALLBACK (on_copy_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->cut), "activate",
                      G_CALLBACK (on_cut_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->insert), "activate",
                      G_CALLBACK (on_insert_pre_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->merge), "activate",
                      G_CALLBACK (on_merge_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->paste_as_new), "activate",
                      G_CALLBACK (on_paste_as_new_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->delete), "activate",
                      G_CALLBACK (on_delete_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->select_all), "activate",
                      G_CALLBACK (on_select_all_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->select_start_only), "activate",
                      G_CALLBACK (on_select_start_only_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->select_end_only), "activate",
                      G_CALLBACK (on_select_end_only_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->select_invert), "activate",
                      G_CALLBACK (on_select_invert_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->select_new), "activate",
                      G_CALLBACK (on_select_new_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->select_to_end), "activate",
                      G_CALLBACK (on_select_to_end_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->select_from_start), "activate",
                      G_CALLBACK (on_select_from_start_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->select_last), "activate",
                      G_CALLBACK (on_select_last_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->lock_selwidth), "activate",
                      G_CALLBACK (on_lock_selwidth_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->record), "activate",
                      G_CALLBACK (on_record_activate),
                      NULL);
  mainw->record_perf_func=g_signal_connect (GTK_OBJECT (mainw->record_perf), "activate",
                      G_CALLBACK (on_record_perf_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->playall), "activate",
                      G_CALLBACK (on_playall_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->rewind), "activate",
                      G_CALLBACK (on_rewind_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->playsel), "activate",
                      G_CALLBACK (on_playsel_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->playclip), "activate",
                      G_CALLBACK (on_playclip_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->stop), "activate",
                      G_CALLBACK (on_stop_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->full_screen), "activate",
                      G_CALLBACK (on_full_screen_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->sw_sound), "activate",
                      G_CALLBACK (on_save_with_sound_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->ccpd_sound), "activate",
                      G_CALLBACK (on_ccpd_sound_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->dsize), "activate",
                      G_CALLBACK (on_double_size_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->sepwin), "activate",
                      G_CALLBACK (on_sepwin_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->fade), "activate",
                      G_CALLBACK (on_fade_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->loop_video), "activate",
                      G_CALLBACK (on_loop_video_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->loop_continue), "activate",
                      G_CALLBACK (on_loop_cont_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->loop_ping_pong), "activate",
                      G_CALLBACK (on_ping_pong_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->mute_audio), "activate",
                      G_CALLBACK (on_mute_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->sticky), "activate",
                      G_CALLBACK (on_sticky_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->showfct), "activate",
                      G_CALLBACK (on_showfct_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->colour_cycle), "activate",
                      G_CALLBACK (on_colour_cycle_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->colorize), "activate",
                      G_CALLBACK (on_colorize_pre_activate),
                      GINT_TO_POINTER (1));
  g_signal_connect (GTK_OBJECT (mainw->colour_filter), "activate",
                      G_CALLBACK (on_colorize_pre_activate),
                      GINT_TO_POINTER (2));
  g_signal_connect (GTK_OBJECT (mainw->edge_detect), "activate",
                      G_CALLBACK (on_edge_detect_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->enhance), "activate",
                      G_CALLBACK (on_enhance_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->flip), "activate",
                      G_CALLBACK (on_flip_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->flop), "activate",
                      G_CALLBACK (on_flop_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->jumble), "activate",
                      G_CALLBACK (on_jumble_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->tunnel), "activate",
                      G_CALLBACK (on_tunnel_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->negate), "activate",
                      G_CALLBACK (on_negate_pre_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->normalize), "activate",
                      G_CALLBACK (on_normalize_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->randomzoom), "activate",
                      G_CALLBACK (on_randomzoom_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->shrink), "activate",
                      G_CALLBACK (on_shrink_pre_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->monochrome), "activate",
                      G_CALLBACK (on_monochrome_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->blank_frames), "activate",
                      G_CALLBACK (on_blank_frames_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->rotate), "activate",
                      G_CALLBACK (on_spin_pre_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->solarize), "activate",
                      G_CALLBACK (on_solarize_pre_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->charcoal), "activate",
                      G_CALLBACK (on_charcoal_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->swirl), "activate",
                      G_CALLBACK (on_swirl_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->transx), "activate",
                      G_CALLBACK (on_shift_pre_activate),
                      GINT_TO_POINTER (1));
  g_signal_connect (GTK_OBJECT (mainw->transy), "activate",
                      G_CALLBACK (on_shift_pre_activate),
                      GINT_TO_POINTER (2));
  g_signal_connect (GTK_OBJECT (mainw->dream), "activate",
                      G_CALLBACK (on_dream_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->wave), "activate",
                      G_CALLBACK (on_wave_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->realtime_fx), "activate",
                      G_CALLBACK (on_realfx_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->preferences), "activate",
                      G_CALLBACK (on_preferences_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->change_speed), "activate",
                      G_CALLBACK (on_change_speed_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->resample_video), "activate",
                      G_CALLBACK (on_resample_video_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->capture), "activate",
                      G_CALLBACK (on_capture_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->reorder), "activate",
		    G_CALLBACK (on_reorder_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->rev_clipboard), "activate",
                      G_CALLBACK (on_rev_clipboard_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->resize), "activate",
                      G_CALLBACK (on_resize_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->trim_frames), "activate",
                      G_CALLBACK (on_trim_frames_pre_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->rotate_all), "activate",
                      G_CALLBACK (on_rotate_all_pre_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->export_selaudio), "activate",
                      G_CALLBACK (on_export_audio_activate),
                      GINT_TO_POINTER (0));
  g_signal_connect (GTK_OBJECT (mainw->export_allaudio), "activate",
                      G_CALLBACK (on_export_audio_activate),
                      GINT_TO_POINTER(1));
  g_signal_connect (GTK_OBJECT (mainw->append_audio), "activate",
                      G_CALLBACK (on_append_audio_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->trim_audio), "activate",
                      G_CALLBACK (on_trim_audio_activate),
                      GINT_TO_POINTER (0));
  g_signal_connect (GTK_OBJECT (mainw->trim_to_pstart), "activate",
                      G_CALLBACK (on_trim_audio_activate),
                      GINT_TO_POINTER (1));
  g_signal_connect (GTK_OBJECT (mainw->delsel_audio), "activate",
                      G_CALLBACK (on_del_audio_activate),
                      GINT_TO_POINTER (0));
  g_signal_connect (GTK_OBJECT (mainw->delall_audio), "activate",
                      G_CALLBACK (on_del_audio_activate),
                      GINT_TO_POINTER (1));
  g_signal_connect (GTK_OBJECT (mainw->ins_silence), "activate",
                      G_CALLBACK (on_ins_silence_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->resample_audio), "activate",
                      G_CALLBACK (on_resample_audio_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->load_audio), "activate",
                      G_CALLBACK (on_load_audio_activate),
                      NULL);
  if (capable->has_cdda2wav==TRUE) {
    g_signal_connect (GTK_OBJECT (mainw->load_cdtrack), "activate",
                      G_CALLBACK (on_load_cdtrack_activate),
                      NULL);
    
    g_signal_connect (GTK_OBJECT (mainw->eject_cd), "activate",
                      G_CALLBACK (on_eject_cd_activate),
                      NULL);
  }

  if (capable->has_xmms==TRUE) {
    g_signal_connect (GTK_OBJECT (mainw->xmms_play_audio), "activate",
                      G_CALLBACK (on_xmms_play_audio_activate),
                      NULL);
    g_signal_connect (GTK_OBJECT (mainw->xmms_random_audio), "activate",
                      G_CALLBACK (on_xmms_random_audio_activate),
                      NULL); 
    g_signal_connect (GTK_OBJECT (mainw->xmms_stop_audio), "activate",
                      G_CALLBACK (on_xmms_stop_audio_activate),
                      NULL);
  }

  g_signal_connect (GTK_OBJECT (mainw->show_file_info), "activate",
                      G_CALLBACK (on_show_file_info_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->show_file_comments), "activate",
                      G_CALLBACK (on_show_file_comments_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->show_clipboard_info), "activate",
                      G_CALLBACK (on_show_clipboard_info_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->rename), "activate",
		    G_CALLBACK (on_rename_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->vj_save_set), "activate",
		    G_CALLBACK (on_save_set_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->vj_load_set), "activate",
		    G_CALLBACK (on_load_set_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (mainw->vj_show_keys), "activate",
		    G_CALLBACK (on_show_keys_activate),
		    NULL);
  mainw->toy_func_none=g_signal_connect (GTK_OBJECT (mainw->toy_none), "activate",
					 G_CALLBACK (on_toy_activate),
					 NULL);
  mainw->toy_func_random_frames=g_signal_connect (GTK_OBJECT (mainw->toy_random_frames), "activate",
						  G_CALLBACK (on_toy_activate),
						  NULL);
  g_signal_connect (GTK_OBJECT (mainw->toy_tv), "activate",
		    G_CALLBACK (on_toy_activate),
		    NULL);
  g_signal_connect (GTK_OBJECT (about), "activate",
                      G_CALLBACK (on_about_activate),
                      NULL);
  mainw->spin_start_func=g_signal_connect_after (GTK_OBJECT (mainw->spinbutton_start), "value_changed",
                      G_CALLBACK (on_spinbutton_start_value_changed),
                      NULL);
  mainw->spin_end_func=g_signal_connect_after (GTK_OBJECT (mainw->spinbutton_end), "value_changed",
                      G_CALLBACK (on_spinbutton_end_value_changed),
                      NULL);

  // these are for the menu transport buttons
  g_signal_connect (GTK_OBJECT (mainw->m_playbutton), "activate",
                      G_CALLBACK (on_playall_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->m_stopbutton), "activate",
                      G_CALLBACK (on_stop_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->m_playselbutton), "activate",
                      G_CALLBACK (on_playsel_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->m_rewindbutton), "activate",
                      G_CALLBACK (on_rewind_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->m_mutebutton), "activate",
                      G_CALLBACK (on_mute_button_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->m_loopbutton), "activate",
                      G_CALLBACK (on_loop_button_activate),
                      NULL);

  // these are 'invisible' buttons for the key accelerators
  g_signal_connect (GTK_OBJECT (mainw->t_stopbutton), "clicked",
                      G_CALLBACK (on_stop_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_bckground), "clicked",
                      G_CALLBACK (on_fade_pressed),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_sepwin), "clicked",
                      G_CALLBACK (on_sepwin_pressed),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_double), "clicked",
                      G_CALLBACK (on_double_size_pressed),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_single), "clicked",
                      G_CALLBACK (on_double_size_pressed),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_fullscreen), "clicked",
                      G_CALLBACK (on_full_screen_pressed),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_infobutton), "clicked",
                      G_CALLBACK (on_show_file_info_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_hide), "clicked",
                      G_CALLBACK (on_toolbar_hide),
                      NULL);




  g_signal_connect (GTK_OBJECT (mainw->t_slower), "clicked",
                      G_CALLBACK (on_slower_pressed),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_faster), "clicked",
                      G_CALLBACK (on_faster_pressed),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_back), "clicked",
                      G_CALLBACK (on_back_pressed),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_forward), "clicked",
                      G_CALLBACK (on_forward_pressed),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_dirchange), "clicked",
                      G_CALLBACK (on_dirchange_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_nextclip), "clicked",
                      G_CALLBACK (on_nextclip_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_prevclip), "clicked",
                      G_CALLBACK (on_prevclip_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_freeze), "clicked",
                      G_CALLBACK (on_freeze_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_grabkeys), "clicked",
                      G_CALLBACK (on_rte_grabkeys_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_rtemode), "clicked",
                      G_CALLBACK (on_rte_switchmode_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_nervous), "clicked",
                      G_CALLBACK (on_nervous_activate),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->t_f1), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GUINT_TO_POINTER (1));
  g_signal_connect (GTK_OBJECT (mainw->t_f2), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (2));
  g_signal_connect (GTK_OBJECT (mainw->t_f3), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (3));
  g_signal_connect (GTK_OBJECT (mainw->t_f4), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (4));
  g_signal_connect (GTK_OBJECT (mainw->t_f5), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (5));
  g_signal_connect (GTK_OBJECT (mainw->t_f6), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (6));
  g_signal_connect (GTK_OBJECT (mainw->t_f7), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (7));
  g_signal_connect (GTK_OBJECT (mainw->t_f8), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (8));
  g_signal_connect (GTK_OBJECT (mainw->t_f9), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (9));
  g_signal_connect (GTK_OBJECT (mainw->t_f10), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (10));
  g_signal_connect (GTK_OBJECT (mainw->t_f11), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (11));
  g_signal_connect (GTK_OBJECT (mainw->t_f12), "clicked",
                      G_CALLBACK (on_storeclip_activate),
                      GINT_TO_POINTER (12));
  g_signal_connect (GTK_OBJECT (mainw->t_rte0), "clicked",
		    G_CALLBACK (on_rte_activate),
		    GUINT_TO_POINTER (EFFECT_NONE));
  g_signal_connect (GTK_OBJECT (mainw->t_rte1), "clicked",
		    G_CALLBACK (on_rte_activate),
		    GUINT_TO_POINTER (EFFECT_ALPHA));
  g_signal_connect (GTK_OBJECT (mainw->t_rte2), "clicked",
		    G_CALLBACK (on_rte_activate),
		    GUINT_TO_POINTER (EFFECT_NOISE));
  g_signal_connect (GTK_OBJECT (mainw->t_rte3), "clicked",
		    G_CALLBACK (on_rte_activate),
		    GUINT_TO_POINTER (EFFECT_NEGATE));
  g_signal_connect (GTK_OBJECT (mainw->t_rte4), "clicked",
		    G_CALLBACK (on_rte_activate),
		    GUINT_TO_POINTER (EFFECT_REMOVE_BG));
  g_signal_connect (GTK_OBJECT (mainw->t_rte5), "clicked",
		    G_CALLBACK (on_rte_activate),
		    GUINT_TO_POINTER (EFFECT_POSTER));
  g_signal_connect (GTK_OBJECT (mainw->t_rte6), "clicked",
		    G_CALLBACK (on_rte_activate),
		    GUINT_TO_POINTER (EFFECT_MIRRORX));
  g_signal_connect (GTK_OBJECT (mainw->t_rte7), "clicked",
		    G_CALLBACK (on_rte_activate),
		    GUINT_TO_POINTER (EFFECT_MIRRORY));
  g_signal_connect (GTK_OBJECT (mainw->t_rte8), "clicked",
		    G_CALLBACK (on_rte_activate),
		    GUINT_TO_POINTER (EFFECT_BLEND));
  g_signal_connect (GTK_OBJECT (mainw->t_rte9), "clicked",
		    G_CALLBACK (on_rte_activate),
		    GUINT_TO_POINTER (EFFECT_EDGE));
  mainw->mouse_fn1=g_signal_connect (GTK_OBJECT (mainw->eventbox2), "motion_notify_event",
                      G_CALLBACK (on_mouse_sel_update),
                      NULL);
  g_signal_handler_block (mainw->eventbox2,mainw->mouse_fn1);
  g_signal_connect (GTK_OBJECT (mainw->eventbox2), "button_release_event",
                      G_CALLBACK (on_mouse_sel_reset),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->eventbox2), "button_press_event",
                      G_CALLBACK (on_mouse_sel_start),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->hruler), "motion_notify_event",
                      G_CALLBACK (return_true),
                      NULL);
  mainw->hrule_func=g_signal_connect (GTK_OBJECT (mainw->eventbox5), "motion_notify_event",
                      G_CALLBACK (on_hrule_update),
                      NULL);
  g_signal_handler_block (mainw->eventbox5,mainw->hrule_func);
  g_signal_connect (GTK_OBJECT (mainw->eventbox5), "button_release_event",
                      G_CALLBACK (on_hrule_reset),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->eventbox5), "button_press_event",
                      G_CALLBACK (on_hrule_set),
                      NULL);
  g_signal_connect (GTK_OBJECT (mainw->eventbox3), "button_press_event",
                      G_CALLBACK (frame_context),
                      GINT_TO_POINTER (1));
  g_signal_connect (GTK_OBJECT (mainw->eventbox4), "button_press_event",
                      G_CALLBACK (frame_context),
                      GINT_TO_POINTER (2));

  gtk_window_add_accel_group (GTK_WINDOW (mainw->LiVES), mainw->accel_group);

  mainw->laudio_drawable=NULL;
  mainw->raudio_drawable=NULL;
  mainw->video_drawable=NULL;
  mainw->plug1=NULL;

}



void
fade_background(void) {

  if (palette->style==STYLE_PLAIN) {
    gtk_label_set_text(GTK_LABEL(mainw->banner),"            = <  L i V E S > =              ");
  }
  if (mainw->foreign==TRUE) {
    gtk_label_set_text(GTK_LABEL(mainw->banner)," DO NOT COVER THE PLAY WINDOW ! ");
    gtk_widget_modify_fg(mainw->banner, GTK_STATE_NORMAL, &palette->banner_fade_text);
  }
  else {
    gtk_widget_modify_bg (mainw->playframe, GTK_STATE_NORMAL, &palette->fade_colour);
    if (mainw->sep_win==TRUE) {
      gtk_widget_hide (mainw->playframe);
    }
    gtk_frame_set_shadow_type (GTK_FRAME(mainw->playframe), GTK_SHADOW_NONE);
  }

  gtk_frame_set_label(GTK_FRAME(mainw->playframe), "");

  gtk_widget_modify_fg (mainw->curf_label, GTK_STATE_NORMAL, &palette->fade_colour);
  gtk_widget_modify_fg (mainw->vps_label, GTK_STATE_NORMAL, &palette->fade_colour);

  gtk_widget_modify_bg (mainw->eventbox3, GTK_STATE_NORMAL, &palette->fade_colour);
  gtk_widget_modify_bg (mainw->eventbox4, GTK_STATE_NORMAL, &palette->fade_colour);
  gtk_widget_modify_bg (mainw->eventbox, GTK_STATE_NORMAL, &palette->fade_colour);

  gtk_widget_modify_bg (mainw->frame1, GTK_STATE_NORMAL, &palette->fade_colour);
  gtk_widget_modify_bg (mainw->frame2, GTK_STATE_NORMAL, &palette->fade_colour);
  gtk_frame_set_shadow_type (GTK_FRAME(mainw->frame1), GTK_SHADOW_NONE);
  gtk_frame_set_label (GTK_FRAME(mainw->frame1), "");
  gtk_frame_set_shadow_type (GTK_FRAME(mainw->frame2), GTK_SHADOW_NONE);
  gtk_frame_set_label (GTK_FRAME(mainw->frame2), "");

  if (mainw->toy_type!=TOY_RANDOM_FRAMES||prefs->video_player==VID_PLAYER_MPLAYER||mainw->foreign==TRUE||cfile->perf_counter>0) {
    gtk_widget_hide(mainw->image272);
    gtk_widget_hide(mainw->image273);
  }
  if (future_prefs->show_tool==TRUE) {
    gtk_widget_show(mainw->toolbar);
  }
  gtk_widget_hide(mainw->menubar);
  gtk_widget_hide(mainw->hseparator);
  gtk_widget_hide(mainw->sep_image);
  gtk_widget_hide(mainw->scrolledwindow);
  gtk_widget_hide(mainw->eventbox2);
  gtk_widget_hide(mainw->spinbutton_start);
  gtk_widget_hide(mainw->hruler);
  gtk_widget_hide(mainw->eventbox5);

  if (prefs->video_player==VID_PLAYER_MPLAYER) {
      gtk_widget_hide(mainw->t_forward);
      gtk_widget_hide(mainw->t_back);
      gtk_widget_hide(mainw->t_slower);
      gtk_widget_hide(mainw->t_faster);
      gtk_widget_hide(mainw->t_fullscreen);
      gtk_widget_hide(mainw->t_sepwin);
      if (mainw->sep_win==TRUE) {
	gtk_widget_hide(mainw->t_double);
	gtk_widget_hide(mainw->t_single);
      }
  }
  else {
    if (mainw->foreign==FALSE) {
      gtk_widget_show(mainw->t_forward);
      gtk_widget_show(mainw->t_back);
      gtk_widget_show(mainw->t_slower);
      gtk_widget_show(mainw->t_faster);
      gtk_widget_show(mainw->t_fullscreen);
      gtk_widget_show(mainw->t_sepwin);
    }
  }

  gtk_widget_hide(mainw->spinbutton_start);
  gtk_widget_hide(mainw->spinbutton_end);
  gtk_widget_hide(mainw->sel_label);
  gtk_widget_hide(mainw->arrow1);
  gtk_widget_hide(mainw->arrow2);

}





void
unfade_background(void) {
  if (palette->style==STYLE_PLAIN) {
    gtk_label_set_text(GTK_LABEL(mainw->banner),"   = <  L i V E S > =                            ");
  }
  else {
    gtk_label_set_text(GTK_LABEL(mainw->banner),"                                                ");
  }
  gtk_widget_modify_fg(mainw->banner, GTK_STATE_NORMAL, &palette->normal_fore);
  gtk_widget_modify_bg (mainw->eventbox, GTK_STATE_NORMAL, &palette->normal_back);
  gtk_widget_modify_bg (mainw->eventbox3, GTK_STATE_NORMAL, &palette->normal_back);
  gtk_frame_set_label (GTK_FRAME(mainw->frame1), "First Frame");
  if (mainw->preview==FALSE) {
    gtk_frame_set_label(GTK_FRAME(mainw->playframe),"Play");
  }
  else {
    gtk_frame_set_label(GTK_FRAME(mainw->playframe),"Preview");
  }

  gtk_frame_set_shadow_type (GTK_FRAME(mainw->frame1), GTK_SHADOW_IN);
  gtk_frame_set_label (GTK_FRAME(mainw->frame2), "Last Frame");
  gtk_widget_modify_fg (mainw->curf_label, GTK_STATE_NORMAL, &palette->normal_fore);
  gtk_widget_modify_fg (mainw->vps_label, GTK_STATE_NORMAL, &palette->normal_fore);

  if (palette->style&STYLE_1) {
    gtk_widget_modify_fg(gtk_frame_get_label_widget(GTK_FRAME(mainw->playframe)), GTK_STATE_NORMAL, &palette->normal_fore);
    gtk_widget_modify_fg(gtk_frame_get_label_widget(GTK_FRAME(mainw->frame1)), GTK_STATE_NORMAL, &palette->normal_fore);
    gtk_widget_modify_fg(gtk_frame_get_label_widget(GTK_FRAME(mainw->frame2)), GTK_STATE_NORMAL, &palette->normal_fore);
  }

  gtk_widget_modify_bg (mainw->eventbox4, GTK_STATE_NORMAL, &palette->normal_back);
  gtk_widget_modify_bg (mainw->frame1, GTK_STATE_NORMAL, &palette->normal_back);
  gtk_widget_modify_bg (mainw->frame2, GTK_STATE_NORMAL, &palette->normal_back);

  gtk_frame_set_shadow_type (GTK_FRAME(mainw->frame2), GTK_SHADOW_IN);
  gtk_widget_modify_bg (mainw->playframe, GTK_STATE_NORMAL, &palette->normal_back);
  gtk_frame_set_shadow_type (GTK_FRAME(mainw->playframe), GTK_SHADOW_IN);
  gtk_widget_show(mainw->menubar);
  gtk_widget_hide(mainw->toolbar);
  gtk_widget_show(mainw->hseparator);
  if (mainw->double_size==FALSE||mainw->sep_win==TRUE) {
    if (palette->style&STYLE_1) {
      gtk_widget_show(mainw->sep_image);
    }
    gtk_widget_show(mainw->scrolledwindow);
  }
  gtk_widget_show(mainw->image272);
  gtk_widget_show(mainw->image273);
  gtk_widget_show(mainw->eventbox2);
  if (cfile->opening==FALSE) {
    gtk_widget_show(mainw->hruler);
    gtk_widget_show(mainw->eventbox5);
  }
  if (cfile->frames>0&&!((prefs->sepwin_type==1&&mainw->sep_win==TRUE)||prefs->video_player==VID_PLAYER_MPLAYER )) {
    gtk_widget_show(mainw->playframe);
  }
  gtk_widget_show(mainw->spinbutton_start);
  gtk_widget_show(mainw->spinbutton_end);
  gtk_widget_show(mainw->sel_label);
  gtk_widget_show(mainw->arrow1);
  gtk_widget_show(mainw->arrow2);
  if (prefs->video_player!=VID_PLAYER_MPLAYER) {
    gtk_widget_show(mainw->spinbutton_pb_fps);
  }
  gtk_widget_modify_fg (mainw->vps_label, GTK_STATE_NORMAL, &palette->normal_fore);
  gtk_widget_modify_fg (mainw->curf_label, GTK_STATE_NORMAL, &palette->normal_fore);


}


void
fullscreen_internal(void) {
  // resize for full screen, internal player, no separate window
  
    gtk_widget_hide(mainw->frame1);
    gtk_widget_hide(mainw->frame2);

    gtk_widget_hide(mainw->eventbox3);
    gtk_widget_hide(mainw->eventbox4);

    gtk_frame_set_label(GTK_FRAME(mainw->playframe),NULL);
    gtk_container_set_border_width (GTK_CONTAINER (mainw->playframe), 0);

    gtk_widget_hide(mainw->t_bckground);
    gtk_widget_hide(mainw->t_double);

    // size of frame in fullscreen, internal
    gtk_image_set_from_pixbuf(GTK_IMAGE(mainw->image274),NULL);
    gtk_widget_set_size_request (mainw->playframe, mainw->eventbox->allocation.width, mainw->fixed_height);
    
    // size of image in fullscreen, internal
    mainw->pheight=mainw->fixed_height;
    mainw->pwidth=mainw->eventbox->allocation.width;

}


void 
block_expose (void) {
  // block expose/config events
  // sometimes we need to do this before showing/re-showing the play window
  // otherwise we get into a loop of expose events
  // symptoms - strace shows the app looping on poll() and it is otherwise
  // unresponsive

  g_signal_handler_block(mainw->video_draw,mainw->config_func);
  g_signal_handler_block(mainw->video_draw,mainw->vidbar_func);
  g_signal_handler_block(mainw->laudio_draw,mainw->laudbar_func);
  g_signal_handler_block(mainw->raudio_draw,mainw->raudbar_func);
}

void 
unblock_expose (void) {
  // unblock expose/config events
  g_signal_handler_unblock(mainw->video_draw,mainw->config_func);
  g_signal_handler_unblock(mainw->video_draw,mainw->vidbar_func);
  g_signal_handler_unblock(mainw->laudio_draw,mainw->laudbar_func);
  g_signal_handler_unblock(mainw->raudio_draw,mainw->raudbar_func);
}

